within ;
package CellularAutomataLib
  class ModelicaLicense2 "Modelica License 2"
    extends Modelica.Icons.Information;
    annotation (Documentation(info="<html>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\">
This page contains the &ldquo;Modelica License 2&rdquo; which was
released by the Modelica Association on Nov. 19, 2008. It is used for
all material from the Modelica Association provided to the public
after this date. It is recommended that other providers of free
Modelica packages license their library also under &ldquo;Modelica
License 2&rdquo;. Additionally, this document contains a description
how to apply the license and has a &ldquo;Frequently Asked Questions&rdquo;
section.</P>
 
<P STYLE=\"text-indent: 0pt; line-height: 150%\">
<A HREF=\"#1. The Modelica License 2|outline\">             The Modelica License 2</A>
   (in other formats: 
   <A HREF=\"http://www.modelica.org/licenses/ModelicaLicense2.html\">standalone html</A>,
   <A HREF=\"http://www.modelica.org/licenses/ModelicaLicense2.pdf\">pdf</A>,
   <A HREF=\"http://www.modelica.org/licenses/ModelicaLicense2.odt\">odt</A>,
   <A HREF=\"http://www.modelica.org/licenses/ModelicaLicense2.doc\">doc</A>)<br>
   <A HREF=\"#2. How to Apply the Modelica License 2|outline\">How to Apply the Modelica License 2</A><br>
   <A HREF=\"#3. Frequently Asked Questions|outline\">         Frequently Asked Questions</A><br>&nbsp;</P>
 
<hr>
<H4><A NAME=\"_Ref208223390\"></A><A NAME=\"1. The Modelica License 2|outline\"></A>
The Modelica License 2</H4>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>Preamble. </B>The goal of this license is that Modelica related
model libraries, software, images, documents, data files etc. can be
used freely in the original or a modified form, in open source and in
commercial environments (as long as the license conditions below are
fulfilled, in particular sections 2c) and 2d). The Original Work is
provided free of charge and the use is completely at your own risk.
Developers of free Modelica packages are encouraged to utilize this
license for their work.</P>
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
The Modelica License applies to any Original Work that contains the
following licensing notice adjacent to the copyright notice(s) for
this Original Work:</P>
<P ALIGN=CENTER STYLE=\"text-indent: 0pt\"><B>Licensed
by &lt;name of Licensor&gt; under the Modelica License 2</B></P>
<P STYLE=\"text-indent: 0pt; widows: 2; orphans: 2\"><B>1.
Definitions.</B></P>
<OL style=\"list-style-type:lower-latin\">
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        &ldquo;License&rdquo; is this Modelica License.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        &ldquo;Original Work&rdquo; is any work of authorship, including
        software, images, documents, data files, that contains the above
        licensing notice or that is packed together with a licensing notice
        referencing it.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        &ldquo;Licensor&rdquo; is the provider of the Original Work who has
        placed this licensing notice adjacent to the copyright notice(s) for
        the Original Work. The Original Work is either directly provided by
        the owner of the Original Work, or by a licensee of the owner.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        &ldquo;Derivative Work&rdquo; is any modification of the Original
        Work which represents, as a whole, an original work of authorship.
        For the matter of clarity and as examples: 
        </P>
        <OL style=\"list-style-type:upper-latin\">
                <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
                Derivative Work shall not include work that remains separable from
                the Original Work, as well as merely extracting a part of the
                Original Work without modifying it.</P>
                <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
                Derivative Work shall not include (a) fixing of errors and/or (b)
                adding vendor specific Modelica annotations and/or (c) using a
                subset of the classes of a Modelica package, and/or (d) using a
                different representation, e.g., a binary representation.</P>
                <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
                Derivative Work shall include classes that are copied from the
                Original Work where declarations, equations or the documentation
                are modified. 
                </P>
                <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
                Derivative Work shall include executables to simulate the models
                that are generated by a Modelica translator based on the Original
                Work (of a Modelica package).</P>
        </OL>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        &ldquo;Modified Work&rdquo; is any modification of the Original Work
        with the following exceptions: (a) fixing of errors and/or (b)
        adding vendor specific Modelica annotations and/or (c) using a
        subset of the classes of a Modelica package, and/or (d) using a
        different representation, e.g., a binary representation.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        &quot;Source Code&quot; means the preferred form of the Original
        Work for making modifications to it and all available documentation
        describing how to modify the Original Work.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        &ldquo;You&rdquo; means an individual or a legal entity exercising
        rights under, and complying with all of the terms of, this License. 
        </P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        &ldquo;Modelica package&rdquo; means any Modelica library that is
        defined with the<BR>&ldquo;<FONT FACE=\"Courier New, monospace\"><FONT SIZE=2 STYLE=\"font-size: 9pt\"><B>package</B></FONT></FONT><FONT FACE=\"Courier New, monospace\"><FONT SIZE=2 STYLE=\"font-size: 9pt\">
        &lt;Name&gt; ... </FONT></FONT><FONT FACE=\"Courier New, monospace\"><FONT SIZE=2 STYLE=\"font-size: 9pt\"><B>end</B></FONT></FONT><FONT FACE=\"Courier New, monospace\"><FONT SIZE=2 STYLE=\"font-size: 9pt\">
        &lt;Name&gt;;</FONT></FONT>&ldquo; Modelica language element.</P>
</OL>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>2. </B><B>Grant of Copyright License. </B>Licensor grants You a
worldwide, royalty-free, non-exclusive, sublicensable license, for
the duration of the copyright, to do the following:</P>
<OL style=\"list-style-type:lower-latin\">
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        To reproduce the Original Work in copies, either alone or as part of
        a collection.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        To create Derivative Works according to Section 1d) of this License.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        To distribute or communicate to the public copies of the <U>Original
        Work</U> or a <U>Derivative Work</U> under <U>this License</U>. No
        fee, neither as a copyright-license fee, nor as a selling fee for
        the copy as such may be charged under this License. Furthermore, a
        verbatim copy of this License must be included in any copy of the
        Original Work or a Derivative Work under this License.<BR>      For
        the matter of clarity, it is permitted A) to distribute or
        communicate such copies as part of a (possible commercial)
        collection where other parts are provided under different licenses
        and a license fee is charged for the other parts only and B) to
        charge for mere printing and shipping costs.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        To distribute or communicate to the public copies of a <U>Derivative
        Work</U>, alternatively to Section 2c), under <U>any other license</U>
        of your choice, especially also under a license for
        commercial/proprietary software, as long as You comply with Sections
        3, 4 and 8 below. <BR>      For the matter of clarity, no
        restrictions regarding fees, either as to a copyright-license fee or
        as to a selling fee for the copy as such apply.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        To perform the Original Work publicly.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
        To display the Original Work publicly.</P>
</OL>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>3. </B><B>Acceptance. </B>Any use of the Original Work or a
Derivative Work, or any action according to either Section 2a) to 2f)
above constitutes Your acceptance of this License.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>4. </B><B>Designation of Derivative Works and of Modified Works.
</B>The identifying designation of Derivative Work and of Modified
Work must be different to the corresponding identifying designation
of the Original Work. This means especially that the (root-level)
name of a Modelica package under this license must be changed if the
package is modified (besides fixing of errors, adding vendor specific
Modelica annotations, using a subset of the classes of a Modelica
package, or using another representation, e.g. a binary
representation).</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>5. </B><B>Grant of Patent License.</B>
Licensor grants You a worldwide, royalty-free, non-exclusive, sublicensable license, 
under patent claims owned by the Licensor or licensed to the Licensor by
the owners of the Original Work that are embodied in the Original Work
as furnished by the Licensor, for the duration of the patents, 
to make, use, sell, offer for sale, have made, and import the Original Work
and Derivative Works under the conditions as given in Section 2. 
For the matter of clarity, the license regarding Derivative Works covers 
patent claims to the extent as they are embodied in the Original Work only.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>6. Provision of </B><B>Source Code. </B>Licensor agrees to provide
You with a copy of the Source Code of the Original Work but reserves
the right to decide freely on the manner of how the Original Work is
provided.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;For the matter of clarity, Licensor might provide only a binary
representation of the Original Work. In that case, You may (a) either
reproduce the Source Code from the binary representation if this is
possible (e.g., by performing a copy of an encrypted Modelica
package, if encryption allows the copy operation) or (b) request the
Source Code from the Licensor who will provide it to You.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>7. </B><B>Exclusions from License Grant. </B>Neither the names of
Licensor, nor the names of any contributors to the Original Work, nor
any of their trademarks or service marks, may be used to endorse or
promote products derived from this Original Work without express
prior permission of the Licensor. Except as otherwise expressly
stated in this License and in particular in Sections 2 and 5, nothing
in this License grants any license to Licensor&rsquo;s trademarks,
copyrights, patents, trade secrets or any other intellectual
property, and no patent license is granted to make, use, sell, offer
for sale, have made, or import embodiments of any patent claims.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;No license is granted to the trademarks of
Licensor even if such trademarks are included in the Original Work,
except as expressly stated in this License. Nothing in this License
shall be interpreted to prohibit Licensor from licensing under terms
different from this License any Original Work that Licensor otherwise
would have a right to license.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>8. </B><B>Attribution Rights. </B>You must retain in the Source
Code of the Original Work and of any Derivative Works that You
create, all author, copyright, patent, or trademark notices, as well
as any descriptive text identified therein as an &quot;Attribution
Notice&quot;. The same applies to the licensing notice of this
License in the Original Work. For the matter of clarity, &ldquo;author
notice&rdquo; means the notice that identifies the original
author(s). <br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;You must cause the Source Code for any Derivative
Works that You create to carry a prominent Attribution Notice
reasonably calculated to inform recipients that You have modified the
Original Work. <br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;In case the Original Work or Derivative Work is not provided in
Source Code, the Attribution Notices shall be appropriately
displayed, e.g., in the documentation of the Derivative Work.</P>
 
<P STYLE=\"text-indent: 0pt\"><B>9. </B><B>Disclaimer
of Warranty. <BR></B><U><B>The Original Work is provided under this
License on an &quot;as is&quot; basis and without warranty, either
express or implied, including, without limitation, the warranties of
non-infringement, merchantability or fitness for a particular
purpose. The entire risk as to the quality of the Original Work is
with You.</B></U><B> </B>This disclaimer of warranty constitutes an
essential part of this License. No license to the Original Work is
granted by this License except under this disclaimer.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>10. </B><B>Limitation of Liability. </B>Under no circumstances and
under no legal theory, whether in tort (including negligence),
contract, or otherwise, shall the Licensor, the owner or a licensee
of the Original Work be liable to anyone for any direct, indirect,
general, special, incidental, or consequential damages of any
character arising as a result of this License or the use of the
Original Work including, without limitation, damages for loss of
goodwill, work stoppage, computer failure or malfunction, or any and
all other commercial damages or losses. This limitation of liability
shall not apply to the extent applicable law prohibits such
limitation.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>11. </B><B>Termination. </B>This License conditions your rights to
undertake the activities listed in Section 2 and 5, including your
right to create Derivative Works based upon the Original Work, and
doing so without observing these terms and conditions is prohibited
by copyright law and international treaty. Nothing in this License is
intended to affect copyright exceptions and limitations. This License
shall terminate immediately and You may no longer exercise any of the
rights granted to You by this License upon your failure to observe
the conditions of this license.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>12. </B><B>Termination for Patent Action. </B>This License shall
terminate automatically and You may no longer exercise any of the
rights granted to You by this License as of the date You commence an
action, including a cross-claim or counterclaim, against Licensor,
any owners of the Original Work or any licensee alleging that the
Original Work infringes a patent. This termination provision shall
not apply for an action alleging patent infringement through
combinations of the Original Work under combination with other
software or hardware.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>13. </B><B>Jurisdiction. </B>Any action or suit relating to this
License may be brought only in the courts of a jurisdiction wherein
the Licensor resides and under the laws of that jurisdiction
excluding its conflict-of-law provisions. The application of the
United Nations Convention on Contracts for the International Sale of
Goods is expressly excluded. Any use of the Original Work outside the
scope of this License or after its termination shall be subject to
the requirements and penalties of copyright or patent law in the
appropriate jurisdiction. This section shall survive the termination
of this License.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>14. </B><B>Attorneys&rsquo; Fees. </B>In any action to enforce the
terms of this License or seeking damages relating thereto, the
prevailing party shall be entitled to recover its costs and expenses,
including, without limitation, reasonable attorneys' fees and costs
incurred in connection with such action, including any appeal of such
action. This section shall survive the termination of this License.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; widows: 2; orphans: 2\">
<B>15. </B><B>Miscellaneous. </B>
</P>
<OL style=\"list-style-type:lower-latin\">
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">If any
        provision of this License is held to be unenforceable, such
        provision shall be reformed only to the extent necessary to make it
        enforceable.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">No verbal
        ancillary agreements have been made. Changes and additions to this
        License must appear in writing to be valid. This also applies to
        changing the clause pertaining to written form.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">You may use the
        Original Work in all ways not otherwise restricted or conditioned by
        this License or by law, and Licensor promises not to interfere with
        or be responsible for such uses by You.</P>
</OL>
 
<hr>
 
<H4><A NAME=\"2. How to Apply the Modelica License 2|outline\"></A>
How to Apply the Modelica License 2</H4>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\">
At the top level of your Modelica package and at every important
subpackage, add the following notices in the info layer of the
package:</P>
 
<table border=\"0\"><tr><td>&nbsp;&nbsp;&nbsp;</td><td>
Licensed by &lt;Licensor&gt; under the Modelica License 2<br>
Copyright &copy; &lt;year1&gt;-&lt;year2&gt;, &lt;name of copyright
holder(s)&gt;. 
</td></tr></table>
 
<table border=\"0\"><tr><td>&nbsp;&nbsp;&nbsp;</td><td>
<I>This Modelica package is <U>free</U> software and
the use is completely at <U>your own risk</U>;
it can be redistributed and/or modified under the terms of the
Modelica license 2, see the license conditions (including the
disclaimer of warranty)
<A HREF=\"modelica://Library.UsersGuide.ModelicaLicense2\">here</A></U>
or at
<A HREF=\"http://www.modelica.org/licenses/ModelicaLicense2\">
http://www.modelica.org/licenses/ModelicaLicense2</A>.
</td></tr></table>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\">Include
a copy of the Modelica License 2 under
<B>&lt;library&gt;.UsersGuide.ModelicaLicense2</B> 
(use <A HREF=\"http://www.modelica.org/licenses/ModelicaLicense2.mo\">
http://www.modelica.org/licenses/ModelicaLicense2.mo</A>). Furthermore, add
the list of authors and contributors under
<B>&lt;library&gt;.UsersGuide.Contributors</B> or 
<B>&lt;library&gt;.UsersGuide.Contact</B>.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\">For
example, sublibrary Modelica.Blocks of the Modelica Standard Library
may have the following notices:</P>
 
<table border=\"0\"><tr><td>&nbsp;&nbsp;&nbsp;</td><td>
Licensed by Modelica Association under the Modelica License 2<br>
Copyright &copy; 1998-2008, Modelica Association. 
</td></tr></table>
 
<table border=\"0\"><tr><td>&nbsp;&nbsp;&nbsp;</td><td>
<I>This Modelica package is <U>free</U> software and
the use is completely at <U>your own risk</U>;
it can be redistributed and/or modified under the terms of the
Modelica license 2, see the license conditions (including the
disclaimer of warranty)
<A HREF=\"modelica://Modelica.UsersGuide.ModelicaLicense2\">here</A></U>
or at
<A HREF=\"http://www.modelica.org/licenses/ModelicaLicense2\">
http://www.modelica.org/licenses/ModelicaLicense2</A>.</I>
</td></tr></table>
 
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\">For
C-source code and documents, add similar notices in the corresponding
file.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\">For
images, add a &ldquo;readme.txt&rdquo; file to the directories where
the images are stored and include a similar notice in this file.</P>
 
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\">In
these cases, save a copy of the Modelica License 2 in one directory
of the distribution, e.g., 
<A HREF=\"http://www.modelica.org/licenses/ModelicaLicense2.html\">
http://www.modelica.org/licenses/ModelicaLicense2.html</A>
in directory <B>&lt;library&gt;/help/documentation/ModelicaLicense2.html</B>.</P>
 
 
<hr>
<H4><A NAME=\"_Ref202857474\"></A><A NAME=\"3. Frequently Asked Questions|outline\"></A>
Frequently Asked Questions</H4>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">
This section contains questions/answer to users and/or distributors of
Modelica packages and/or documents under Modelica License 2. Note,
the answers to the questions below are not a legal interpretation of
the Modelica License 2. In case of a conflict, the language of the
license shall prevail.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\"><BR>
</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; color: green; font-size:140%\">
<b>Using or Distributing a Modelica <U>Package</U> under the Modelica License 2</b></P>
 
<P STYLE=\"text-indent: 0pt\"><B>What are the main
differences to the previous version of the Modelica License?</B></P>
<OL>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">
        Modelica License 1 is unclear whether the licensed Modelica package
        can be distributed under a different license. Version 2 explicitly
        allows that &ldquo;Derivative Work&rdquo; can be distributed under
        any license of Your choice, see examples in Section 1d) as to what
        qualifies as Derivative Work (so, version 2 is clearer).</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">
        If You modify a Modelica package under Modelica License 2 (besides
        fixing of errors, adding vendor specific Modelica annotations, using
        a subset of the classes of a Modelica package, or using another
        representation, e.g., a binary representation), you must rename the
        root-level name of the package for your distribution. In version 1
        you could keep the name (so, version 2 is more restrictive). The
        reason of this restriction is to reduce the risk that Modelica
        packages are available that have identical names, but different
        functionality.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">
        Modelica License 1 states that &ldquo;It is not allowed to charge a
        fee for the original version or a modified version of the software,
        besides a reasonable fee for distribution and support<SPAN LANG=\"en-GB\">&ldquo;.
        Version 2 has a </SPAN>similar intention for all Original Work under
        <U>Modelica License 2</U> (to remain free of charge and open source)
        but states this more clearly as &ldquo;No fee, neither as a
        copyright-license fee, nor as a selling fee for the copy as such may
        be charged&rdquo;. Contrary to version 1, Modelica License 2 has no
        restrictions on fees for Derivative Work that is provided under a
        different license (so, version 2 is clearer and has fewer
        restrictions).</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">
        Modelica License 2 introduces several useful provisions for the
        licensee (articles 5, 6, 12), and for the licensor (articles 7, 12,
        13, 14) that have no counter part in version 1.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">
        Modelica License 2 can be applied to all type of work, including
        documents, images and data files, contrary to version 1 that was
        dedicated for software only (so, version 2 is more general).</P>
</OL>
 
<P STYLE=\"text-indent: 0pt\"><B>Can I distribute a
Modelica package (under Modelica License 2) as part of my commercial
Modelica modeling and simulation environment?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">Yes,
according to Section 2c). However, you are not allowed to charge a
fee for this part of your environment. Of course, you can charge for
your part of the environment. 
</P>
 
<P STYLE=\"text-indent: 0pt\"><B>Can I distribute a
Modelica package (under Modelica License 2) under a different
license?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">No.
The license of an unmodified Modelica package cannot be changed
according to Sections 2c) and 2d). This means that you cannot <U>sell</U>
copies of it, any distribution has to be free of charge.</P>
 
<P STYLE=\"text-indent: 0pt\"><B>Can I distribute a
Modelica package (under Modelica License 2) under a different license
when I first encrypt the package?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">No.
Merely encrypting a package does not qualify for Derivative Work and
therefore the encrypted package has to stay under Modelica License 2.</P>
 
 
<P STYLE=\"text-indent: 0pt\"><B>Can I distribute a
Modelica package (under Modelica License 2) under a different license
when I first add classes to the package?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">No.
The package itself remains unmodified, i.e., it is Original Work, and
therefore the license for this part must remain under Modelica
License 2. The newly added classes can be, however, under a different
license. 
</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\"><B>Can
I copy a class out of a Modelica package (under Modelica License 2)
and include it </B><U><B>unmodified</B></U><B> in a Modelica package
under a </B><U><B>commercial/proprietary license</B></U><B>?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">No,
according to article 2c). However, you can include model, block,
function, package, record and connector classes in your Modelica
package under <U>Modelica License 2</U>. This means that your
Modelica package could be under a commercial/proprietary license, but
one or more classes of it are under Modelica License 2.<BR>Note, a
&ldquo;type&rdquo; class (e.g., type Angle = Real(unit=&rdquo;rad&rdquo;))
can be copied and included unmodified under a commercial/proprietary
license (for details, see the next question).</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\"><B>Can
I copy a type class or </B><U><B>part</B></U><B> of a model, block,
function, record, connector class, out of a Modelica package (under
Modelica License 2) and include it modified or unmodified in a
Modelica package under a </B><U><B>commercial/proprietary</B></U><B>
license</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">Yes,
according to article 2d), since this will in the end usually qualify
as Derivative Work. The reasoning is the following: A type class or
part of another class (e.g., an equation, a declaration, part of a
class description) cannot be utilized &ldquo;by its own&rdquo;. In
order to make this &ldquo;usable&rdquo;, you have to add additional
code in order that the class can be utilized. This is therefore
usually Derivative Work and Derivative Work can be provided under a
different license. Note, this only holds, if the additional code
introduced is sufficient to qualify for Derivative Work. Merely, just
copying a class and changing, say, one character in the documentation
of this class would be no Derivative Work and therefore the copied
code would have to stay under Modelica License 2.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\"><B>Can
I copy a class out of a Modelica package (under Modelica License 2)
and include it in </B><U><B>modified </B></U><B>form in a
</B><U><B>commercial/proprietary</B></U><B> Modelica package?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">Yes.
If the modification can be seen as a &ldquo;Derivative Work&rdquo;,
you can place it under your commercial/proprietary license. If the
modification does not qualify as &ldquo;Derivative Work&rdquo; (e.g.,
bug fixes, vendor specific annotations), it must remain under
Modelica License 2. This means that your Modelica package could be
under a commercial/proprietary license, but one or more parts of it
are under Modelica License 2.</P>
 
<P STYLE=\"text-indent: 0pt\"><B>Can I distribute a
&ldquo;save total model&rdquo; under my commercial/proprietary
license, even if classes under Modelica License 2 are included?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">Your
classes of the &ldquo;save total model&rdquo; can be distributed
under your commercial/proprietary license, but the classes under
Modelica License 2 must remain under Modelica License 2. This means
you can distribute a &ldquo;save total model&rdquo;, but some parts
might be under Modelica License 2.</P>
 
<P STYLE=\"text-indent: 0pt\"><B>Can I distribute a
Modelica package (under Modelica License 2) in encrypted form?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">Yes.
Note, if the encryption does not allow &ldquo;copying&rdquo; of
classes (in to unencrypted Modelica source code), you have to send
the Modelica source code of this package to your customer, if he/she
wishes it, according to article&nbsp;6.</P>
 
<P STYLE=\"text-indent: 0pt\"><B>Can I distribute an
executable under my commercial/proprietary license, if the model from
which the executable is generated uses models from a Modelica package
under Modelica License 2?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">Yes,
according to article 2d), since this is seen as Derivative Work. The
reasoning is the following: An executable allows the simulation of a
concrete model, whereas models from a Modelica package (without
pre-processing, translation, tool run-time library) are not able to
be simulated without tool support. By the processing of the tool and
by its run-time libraries, significant new functionality is added (a
model can be simulated whereas previously it could not be simulated)
and functionality available in the package is removed (e.g., to build
up a new model by dragging components of the package is no longer
poss" + "ible with the executable).</P>
 
<P STYLE=\"text-indent: 0pt\"><B>Is my modification to
a Modelica package (under Modelica License 2) a Derivative Work?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">It
is not possible to give a general answer to it. To be regarded as &quot;an
original work of authorship&quot;, a derivative work must be
different enough from the original or must contain a substantial
amount of new material. Making minor changes or additions of little
substance to a preexisting work will not qualify the work as a new
version for such purposes. 
</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\"><BR>
</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium; color: green; font-size:140%\">
<b>Using or Distributing a Modelica <U>Document</U> under the Modelica License 2</b></P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\">This
section is devoted especially for the following applications:</P>
<OL>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">
        A Modelica tool extracts information out of a Modelica package and
        presents the result in form of a &ldquo;manual&rdquo; for this
        package in, e.g., html, doc, or pdf format.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">
        The Modelica language specification is a document defining the
        Modelica language. It will be licensed under Modelica License 2.</P>
        <LI><P STYLE=\"text-indent: 0pt; font-weight: medium\">
        Someone writes a book about the Modelica language and/or Modelica
        packages and uses information which is available in the Modelica
        language specification and/or the corresponding Modelica package.</P>
</OL>
 
<P STYLE=\"text-indent: 0pt\"><B>Can I sell a manual
that was basically derived by extracting information automatically
from a Modelica package under Modelica License 2 (e.g., a &ldquo;reference
guide&rdquo; of the Modelica Standard Library):</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">Yes.
Extracting information from a Modelica package, and providing it in a
human readable, suitable format, like html, doc or pdf format, where
the content is significantly modified (e.g. tables with interface
information are constructed from the declarations of the public
variables) qualifies as Derivative Work and there are no restrictions
to charge a fee for Derivative Work under alternative 2d).</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\"><B>Can
I copy a text passage out of a Modelica document (under Modelica
License 2) and use it </B><U><B>unmodified</B></U><B> in my document
(e.g. the Modelica syntax description in the Modelica Specification)?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">Yes.
In case you distribute your document, the copied parts are still
under Modelica License 2 and you are not allowed to charge a license
fee for this part. You can, of course, charge a fee for the rest of
your document.</P>
 
<P STYLE=\"text-indent: 0pt; font-weight: medium\"><B>Can
I copy a text passage out of a Modelica document (under Modelica
License 2) and use it in </B><U><B>modified</B></U><B> form in my
document?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">Yes,
the creation of Derivative Works is allowed. In case the content is
significantly modified this qualifies as Derivative Work and there
are no restrictions to charge a fee for Derivative Work under
alternative 2d).</P>
 
<P STYLE=\"text-indent: 0pt\"><B>Can I sell a printed
version of a Modelica document (under Modelica License 2), e.g., the
Modelica Language Specification?</B></P>
<P STYLE=\"text-indent: 0pt; font-weight: medium\">No,
if you are not the copyright-holder, since article 2c) does not allow
a selling fee for a (in this case physical) copy. However, mere
printing and shipping costs may be recovered.</P>
</html>
"));
  end ModelicaLicense2;

  class UsersGuide "Users Guide"
    extends Modelica.Icons.Information;
    class NewModels "Development of new CA models"
      extends Modelica.Icons.Information;
      annotation (Documentation(info="<html>
<p><b><font style=\"font-size: 14pt; color: #008000; \">Development of new cellular automata models using <i>CellularAutomataLib</font></b></i></p>
<p>The procedure to create a cellular automata model can be divided in the following steps: </p>
<p><b><font style=\"font-size: 11pt; color: #008000; \">1. Describe the state and behavior of the model using C functions.</font></b></p>
<p>The basic description of the model has to be performed using external C functions. The file <code>draft.c</code> can serve as a template to develop the functions required to describe the new automata. The contents of that file are:</p>
<p><ul>
<li><code>typedef struct State </code>is a C struct that can be used to describe the state of the cells in the automata</li>
<li><code>DefaultState</code> is the function used to define the default value of the state for all the cells in the automata.</li>
<li><code>Create</code> is the function used to create the cellular space of the automata. It is basically a wrapper function that defines a pointer to the previously defined <code>DefaultState</code> function and calls the <code>CS2D_Create</code> function from <code>CellularAutomataLib.c</code>.</li>
<li><code>InitialState</code> is a function used to define the value of the state for initalized cells. Note that the cell will already be in the default state when this function is called.</li>
<li><code>Ini</code> is the function used to initialize the cells. Like the <code>Create</code> function it is basically a wrapper function that defines a pointer to <code>InitialState</code> and calls <code>CS2D_Init</code>.</li>
<li><code>transition</code> is the function used to define the behavior of the cell during a transition. This function receives the current state of the cell, the state of the neighbors (including the number of neighbors and which of them are present, because border cells may not have present all the neighbors defined in the neighborhood) and the received inputs (including the number of inputs and an boolean array indicating which input has been recived). Note that <code>void</code> pointers have to be casted into <code>State</code> pointers in order to access the values of states.</li>
<li><code>Display</code> is the function used to translate the value of the state into a <code>double</code> value that will be displayed in the graphical animation.</li>
<li><code>Step</code> is the fuction used to execute a simulation step in the automata. It is a wrapper function that creates pointers to the <code>transtion</code> and <code>Display</code> functions, and calls the <code>CS2D_Step</code> function.</li>
<li><code>ExtInit</code> is the function used to translate an external double value into the initial state of a cell. This function must call <code>CS2D_Init</code> at the end with a <code>NULL</code> pointer as fourth parameter. This function is intented to be used with the external init region interface model (<code>ExtInitRegion</code>).</li>
<li><code>SetInput </code>is the function used to set the state of a cell from one cellular space as an input for another cellular space. This function has to allocate dynamic memory for the new input. Note that the data type of the inputs set using this function and the ones set using the <code>ExtInput</code> function has to be the same. This function is intented to be used with the input region interface model (<code>InputRegion</code>).</li>
<li><code>ExtInput</code> is the function used to translate an external <code>double</code> value into an input for a cellular space. This function has to allocate dynamic memory for the new input. Note that the data type of the inputs set using this function and the ones set using the <code>SetInput</code> function has to be the same. This function is intended to be used with the external input region interface model (<code>ExtInputRegion</code>).</li>
<li><code>Output</code> is the function used to translate the value of the state into a <code>double</code> value, that could be observed and used by other Modelica models. This function is intended to be used with the output region interface model (<code>OutputRegion</code>).</li>
</ul></p>
<p>All these functions will be called from Modelica functions using the external function interface.</p>
<p><b><font style=\"font-size: 11pt; color: #008000; \">2. Declare the cellular automata in Modelica</font></b></p>
<p>The cellular automata in Modelica is described by: the<b> cellular space</b> and the <b>interface</b> models.</p>
<p>The cellular space is described by the <code>CellSpace1D</code> and <code>CellSpace2D</code> partial models. Thus, a new cellular space has to extend one of these two models, depending on the dimension of the space. Each cellular space contains three functions: <i>Rule</i>, <i>Create</i> and <i>Initial</i>. These three functions have to be redeclared with Modelica functions that perform the call to the previously defined external C functions (<i>Rule</i> should call the <code>Step</code> function, <i>Create</i> should call <code>Create</code> and <i>Initial</i> should call <code>Ini</code>).</p>
<p>The cellular space has the following parameters:</p>
<p><ul>
<li><i>space_nrows</i> defines the number of rows of the space (only used in 2D spaces).</li>
<li><i>space_ncols</i> defines the number of columns of the space.</li>
<li><i>neighborhood</i> defines the topology of the neighborhood. It contains a list of the relative positions of the neighbors from the center cell.</li>
<li><i>n_inputs</i> defines the number of inputs received from interface models connected to the automata.</li>
<li><i>wrapped_borders </i>defines the boundary conditions. In 1D spaces it is either 1 for wrapped or 0 for non-wrapped. In 2D spaces it can be 0 for non-wrapped, 1 for wrapped only north-to-south, 2 for wrapped only east-to-west and 3 for wrapped in all directions.</li>
<li><i>Tstep</i> defines the interval between two steps in the simulation of the automata.</li>
<li><i>Initial_step</i> defines the time for performing the first simulation step.</li>
<li><i>plot_animation </i>defines if the graphical animation is generated (value 1) or not (value 0).</li>
<li><i>plot_range</i> defines the maximum value of the variable displayed in the animation. Thus, the displayed variable can be in the [0,<i>plot_range</i>] interval.</li>
<li><i>display_delay</i> defines a delay in the graphical animation that can be used to improve its visualization, which otherwise could be too fast to be observed.</li>
<li><i>init_cells </i>defines a list of coordinates of the cells that will be initialized at the beginning of the simulation.</li>
<li><i>name</i> defines a name for the automata that will be displayed in the graphical animation.</li>
</ul></p>
<p>At the beginning of the simulation the cellular space model creates the space using the <i>Create</i> function, and initializes the cells indicated in the <i>init_cells</i> parameter. After that, it performs periodic simulation steps every <i>Tstep</i> time, starting at<i> time = Initial_step</i> (i.e., <code>sample(Initial\\_step,Tstep)</code>).</p>
<p>The cellular space created using this procedure can be simulated and will generate a graphical animation of the simulation. However, the state of the cells and its evolution cannot be observed since all he values are defined externally to Modelica. In order to observe the values of the state output region models have to be included in the CA model. The use of the interface models is described in this <a href=\"modelica://CellularAutomataLib.UsersGuide.InterfaceModels\">section</a>.</p>
<p><b><font style=\"font-size: 11pt; color: #008000; \">Input Region</font></b></p>
<p>Cellular spaces can be combined between them to increase the modeling functionality of the library. This communication can be performed using the<i> Input_Region</i> model. The same model can be used between 1D and 2D spaces.</p>
<p>The combination is performed by using the state of some cells from one space as inputs for the other. The prototype of the transition function in C includes a vector of the received inputs, in order to allow the user to manage them. Each <i>Input_Region</i> has associated an input identifier, set using the parameter <i>input_id</i>, that can be used as index for the vector of inputs of the transition function.</p>
<p>The<i> Input_Region</i> model has two interface ports: <i>FROM</i> and <i>TO</i>. These interface ports are used to connect to the cellular spaces involved. The state of the cell<i> [i,j] | i &isin; [RstartFrom:RendFrom]</i>, <i>j &isin; [CstartFrom:CendFrom]</i>, in the <i>FROM</i> space, is used as an input for the cell <i>[m,n] | m &isin; [RstartTo,RstartTo+(RendFrom-RstartFrom)]</i>, <i>n &isin; [CstartTo,CstartTo+(CendFrom-CstartFrom)]</i> in the <i>TO</i> space. <i>RstartFrom</i>, <i>RendFrom</i>, <i>CstartFrom</i>, <i>CendFrom</i>, <i>RstartTo</i> and <i>CstartTo</i> are parameters of the model. </p>
<p>In 1D spaces only the column parameters are used (i.e., <i>CstartFrom</i>, <i>CendFrom</i> and <i>CstartTo</i>). An additional parameter, named <i>column_1D_2D</i>, allows to use a 1D region as a column, instead of a row, of inputs for a 2D space. The communication is started at <i>time = comm_start</i> and is performed every<i> comm_rate</i> time.</p>
</html>"));
    end NewModels;

    class InterfaceModels "Interfaces with other Modelica models"
      extends Modelica.Icons.Information;
      annotation (Documentation(info="<html>
<p><b><font style=\"font-size: 14pt; color: #008000; \">Interface models included in <i>CellularAutomataLib</font></b></i></p>
<p>The library includes three interface models that can be used to combine CA models with other Modelica models.</p>
<p><br/><b><font style=\"font-size: 11pt; color: #008000; \">External Input Region</font></b></p>
<p>Similarly to the <i>Input_Region</i> model, the model <i>ExtInputRegion</i> can be used to set an input to a region of cells in the automata. In this case the input is generated using an external signal instead of the state of the cells of other automata.</p>
<p>The model receives an external Real input signal through port <i>u</i>, which is used as input for a region of cells in the automata connected to port <i>TO</i>. A 2D region is defined by the positions between <i>Rstart</i> and <i>Rend</i> (for the rows) and <i>Cstart</i> and <i>Cend</i> (for the columns). In 1D regions only the parameters referring to columns are considered.</p>
<p>The input is assigned to the position <i>input_id</i> of the vector of inputs which is available for the user in the transition function. The external signal can be observed in the following ways (defined by the parameter <i>Input_type</i>), in order to be converted into an input:</p>
<p><ul>
<li><i>Quantizer</i>: the input is set every time the value of the signal changes in a defined value or quantum.</li>
<li><i>Cross_UP</i>: the input is set every time the value of the signal crosses a defined threshold in the upwards direction.</li>
<li><i>Cross_DOWN</i>: the input is set every time the value of the signal crosses a defined threshold in the downwards direction.</li>
<li><i>Cross_ANY</i>: the input is set every time the value of the signal crosses a defined threshold in any direction.</li>
<li><i>Sample</i>: the input is set periodically using the <code>sample</code> operator.</li>
</ul></p>
<p>The signal is translated into an input using the function <i>ExtInput</i>, that has to be redeclared to manage the data types used for the inputs in the model.</p>
<p><br/><b><font style=\"font-size: 11pt; color: #008000; \">External Init Region</font></b></p>
<p>This model can be used to set the initial state of a region of cells in the space using the value of an external signal. The model has an input port, named <i>u</i>, where a Real signal is received, and a port named <i>TO</i> that connects to the CA. This signal is translated, using the <i>ExtInit</i> function, into a cell state that will be used to initialize the cells in the region of the automata connected to port <i>TO</i>.</p>
<p>The 2D region is defined by the positions between <i>Rstart</i> and <i>Rend</i> (for the rows) and <i>Cstart </i>and <i>Cend</i> (for the columns). Only the column parameters are considered for 1D regions. </p>
<p>The <i>ExtInit</i> function has to be redeclared using an external C function to manage the data type used to define the state of the cells. This function can be redeclared using different external functions if different signal-to-state translations are required for different regions of the automata.</p>
<p><br/><b><font style=\"font-size: 11pt; color: #008000; \">Output Region</font></b></p>
<p>The <i>OutputRegion</i> model can be used to observe the state of the cells in a region of the automata connected to port <i>FROM</i>. The state is translated into an output Real signal that can be used by other Modelica models.</p>
<p>As in the previous interface models, a 2D region is defined by the positions between <i>Rstart</i> and <i>Rend</i> (for the rows) and <i>Cstart</i> and <i>Cend</i> (for the columns). In 1D regions only the parameters referring to columns are considered.</p>
<p><br/>The model contains two output Real ports, <i>y</i> and <i>yM[Rend-Rstart+1,Cend-Cstart+1]</i> (being <i>yM[Cend-Cstart+1]</i> for the 1D case). Depending on the value of the parameter \\modelica{Output\\_type}, the state is observed in different ways:</p>
<p><ol>
<li>(AVERAGE): the value of <i>y</i> is calculated as the average value of the states of the cells in the <i>[Rstart:Rend,Cstart:Cend]</i> interval, or <i>[Cstart:Cend]</i> for 1D. </li>
<li>(MAX): the value of <i>y</i> is calculated as the maximum value of the states of the cells in the <i>[Rstart:Rend,Cstart:Cend]</i> interval, or <i>[Cstart:Cend]</i> for 1D. </li>
<li>(MIN): the value of <i>y</i> is calculated as the minimum value of the states of the cells in the <i>[Rstart:Rend,Cstart:Cend]</i> interval, or <i>[Cstart:Cend]</i> for 1D. </li>
<li>(MATRIX): the value of the state of the <i>i,j</i>-th cell in the space is assigned to <i>yM[m,n]</i> (where <i>m=1:(Rend-Rstart+1)</i> and <i>n=1:(Cend-Cstart+1)</i>). In 1D, the <i>i</i>-th cell is assigned to <i>yM[n]</i> (where <i>n=1:(Cend-Cstart+1)</i>)</li>
</ol></p>
<p>The value of the state is translated into a Real value using the <i>ExtOutput</i> function, that has to be redeclared to manage the data structure used to define the state.</p>
</html>"));
    end InterfaceModels;
    annotation (Documentation(info="<html>
<p><b><font style=\"font-size: 14pt; color: #008000; \">Users Guide of CellularAutomataLib</font></b> </p>
<p><b><font style=\"font-size: 11pt; color: #008000; \">Cellular Automata</font></b> </p>
<p>Cellular automata (CA) are a class of models initially proposed in the 1940s by John von Neumann and Stanislaw Ulam. </p>
<p>CA are dynamic, discrete-time and discrete-space models. They are represented as a grid of identical discrete volumes, named cells. The grid can be in any finite number of dimensions. The state of each single cell is finite and it is usually represented using integer numbers. The operational dynamics of the automata is described by a rule or transition function that is used to update the state of each cell at discrete time steps. This rule constitutes a function of the current state of the cell and the state of its neighbors, and defines the state of the cell for the next time step. </p>
<p>Examples of different neighborhoods are:the Moore&rsquo;s neighborhood that includes all the surrounding cells; the von Neumann&rsquo;s neighborhood that includes the cells adjoining the four faces of one cell; or the extended von Neumann&rsquo;s that also includes each cell just beyond one of the four adjoining cells. </p>
<p><img src=\"moore.png\"/> <img src=\"neumann.png\"/> <img src=\"neumann-ext.png\"/> </p>
<p>As it can be observed, the definition and behavior of the CA are simple. CA can provide an intuitive way of describing complex behavior using simple rules. CA may be considered as discrete idealizations in time and space of physical systems. Due to its simplicity, CA have been used to describe models of complex systems in multiple domains. CA models have been developed in areas like chemistry, economics, medicine, biology and environment, and urban architecture, among many others. </p>
<p><b><font style=\"font-size: 11pt; color: #008000; \">Structure of the library</font></b> </p>
<p>The library is composed of the following models and packages: </p>
<p><ul>
<li><i>Path_gnuplot</i>: is a constant that has to be configured with the path to the Gnuplot binary in order to automatically generate the graphical animation of the simulation. </li>
<li><i>Input_Region</i>: is an interface model that can be used to combine several CA models. It can be used between 1D and 2D cellular spaces. </li>
<li><i>CAport</i>: connector that is used to connect CA models with the interface models. It only contains a variable whose value represents a reference to a cellular space (i.e., a pointer to dynamic memory). </li>
<li><i>CA_1D</i>: contains the model of the 1D cellular space and the interface models used with 1D spaces. Its contents are not shown in the figure because they are analogous to the contents of the 2D package. </li>
<li><i>Examples1D</i>: contains models of the elementary automata described by Stephen Wolfram as Rule 30 and Rule 110. </li>
<li><i>CA_2D</i>: contains the model of the 2D cellular space, named CellSpace2D, and the interface models used with 2D spaces, named ExtInitRegion2D, InputRegion2D, ExtInputRegion2D and OutputRegion2D. </li>
<li><i>Examples2D</i>: contains six examples of 2D cellular spaces: the game of life , a simple furnace, heat transfer on a chip, Chagas disease, SIR epidemics spread and a forest fire spread model. </li>
<li><i>ExamplesMixed</i>: contains the model of a cement clinker cooler, where 1D and 2D automata are combined. This model is still under development. </li>
</ul></p>
<p>CA models in this library are described using the following components (see figure below): </p>
<p><ul>
<li>The cellular space, represents the 1D or 2D grid of cells. </li>
<li>Interface models, that are used to combine CA models with other Modelica models. </li>
</ul></p>
<p>The behavior of these components is defined using external C functions (e.g., written in a file named <code>Model.c</code>), that include the description of the state of the cells and the functions to: create the cellular space, initalize the required cells, define the transition rules, and convert the state to the types required by the interface models.</p>
<p>The simulation algorithms of the cellular automata are included in the file <code>CellularAutomataLib.c</code>, whose functions are used by the functions in <code>Model.c</code>. </p>
<p><img src=\"externalarch.png\"/> </p>
</html>"));
  end UsersGuide;
  //constant String Path_gnuplot="C:\\gnuplot\\bin\\gnuplot -persist"; //WINDOWS
  constant String Path_gnuplot="/usr/bin/gnuplot -persist"; // LINUX
  model InputRegion
    "Input Regionregion of FROM.space CA is used as input for TO.space CA"
    parameter Integer input_id=1 "ID for input in TO.space model";
    parameter Integer num_dimFrom=2 "Dimension of FROM CA";
    parameter Integer num_dimTo=2 "Dimension of TO CA";
    parameter Integer CstartFrom=1 "FROM region initial column";
    parameter Integer CendFrom=1 "FROM region final column";
    parameter Integer RstartFrom=1 "FROM region initial row (only 2D)";
    parameter Integer RendFrom=1 "FROM region final row (only 2D)";
    parameter Integer CstartTo=1 "TO region initial column";
    //  parameter Integer CendTo = 1 "region final column";
    parameter Integer RstartTo=1 "TO region initial row (only 2D)";
    //  parameter Integer RendTo = 1 "region final row (only 2D)";
    parameter Boolean column_1D_2D=false
      "assign 1D region to 2D column (otherwise row is assigned)";
    parameter Real comm_start=0 "Time for starting communication";
    parameter Real comm_rate=1 "Communication sampling interval";
    replaceable function SetInput
      "External function used to communicate CA states"
      input Integer Fspace "FROM space";
      input Integer Frow "FROM row";
      // 0 if 1D
      input Integer Fcol "FROM column";
      input Integer Tspace "TO space";
      input Integer Trow "TO row";
      // 0 if 1D
      input Integer Tcol "TO column";
      input Integer input_id "input ID";
    end SetInput;
  protected
    Integer iTo;
    Integer jTo;
  public
    input CAport FROM "Input CA model" annotation (Placement(transformation(
            extent={{-80,-10},{-60,10}}), iconTransformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={-50,0})));
    input CAport TO "Output CA model" annotation (Placement(transformation(
            extent={{40,-10},{60,10}}), iconTransformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={50,0})));
  algorithm
    when sample(comm_start, comm_rate) then
      if num_dimFrom == 1 and num_dimTo == 1 then
        // 1D - 1D
        iTo := CstartTo;
        for i in CstartFrom:CendFrom loop
          SetInput(
              FROM.space,
              0,
              i,
              TO.space,
              0,
              iTo,
              input_id);
          /*        CA_1D.CS1D_SetInput(
            TO.space,
            iTo,
            CA_1D.CS1D_Get(FROM.space, i),
            input_id);*/
          iTo := iTo + 1;
        end for;
      elseif num_dimFrom == 1 and num_dimTo == 2 then
        // 1D - 2D
        iTo := RstartTo;
        jTo := CstartTo;
        for i in CstartFrom:CendFrom loop
          SetInput(
              FROM.space,
              0,
              i,
              TO.space,
              iTo,
              jTo,
              input_id);
          /*        CA_2D.CS2D_SetInput(
            TO.space,
            iTo,
            jTo,
            CA_1D.CS1D_Get(FROM.space, i),
            input_id);*/
          if column_1D_2D then
            // assign to column in 2D
            jTo := jTo + 1;
          else
            // assign to row in 2D
            iTo := iTo + 1;
          end if;
        end for;
      elseif num_dimFrom == 2 and num_dimTo == 1 then
        // 2D - 1D
        iTo := CstartTo;
        if RstartFrom == RendFrom then
          // assign from column in 2D
          for i in CstartFrom:CendFrom loop
            SetInput(
                FROM.space,
                RstartFrom,
                i,
                TO.space,
                0,
                iTo,
                input_id);
            /*          CA_1D.CS1D_SetInput(
              TO.space,
              iTo,
              CA_2D.CS2D_Get(
                FROM.space,
                RstartFrom,
                i),
              input_id);*/
            iTo := iTo + 1;
          end for;
        else
          // assign from row in 2D
          for i in RstartFrom:RendFrom loop
            SetInput(
                FROM.space,
                i,
                CstartFrom,
                TO.space,
                0,
                iTo,
                input_id);
            /*CA_1D.CS1D_SetInput(
              TO.space,
              iTo,
              CA_2D.CS2D_Get(
                FROM.space,
                i,
                CstartFrom),
              input_id);*/
            iTo := iTo + 1;
          end for;
        end if;
      elseif num_dimFrom == 2 and num_dimTo == 2 then
        //2D - 2D
        iTo := RstartTo;
        for i in RstartFrom:RendFrom loop
          jTo := CstartTo;
          for j in CstartFrom:CendFrom loop
            SetInput(
                FROM.space,
                i,
                j,
                TO.space,
                iTo,
                jTo,
                input_id);
            /*          CA_2D.CS2D_SetInput(
              TO.space,
              iTo,
              jTo,
              CA_2D.CS2D_Get(
                FROM.space,
                i,
                j),
              input_id);*/
            jTo := jTo + 1;
          end for;
          iTo := iTo + 1;
        end for;
      end if;
    end when;
    annotation (
      Documentation(info="<HTML>
<p>
This model can be used to use the state of the cells from one CA model (connected to </font><tt>FROM</tt> port) as an input to another CA model 
(connected to </font><tt>TO</tt> port).
In this way, the state of </font><tt>FROM</tt> could be used in the transition rule of </font><tt>TO</tt>.
</p>
<h4>Description</h4>
<p>
The model assigns the state of the <i>[i,j]</i> cell in </font><tt>FROM</tt> as an input to the <i>[m,n]</i> cell in </font><tt>TO</tt>,
using </font><tt>input_id</tt> as an index for the vector of inputs. 
The indexes in </font><tt>FROM</tt> vary between </font><tt>RstartFrom:RendFrom</tt> for <i>i</i>, and </font><tt>CstartFrom:CendFrom</tt> for <i>j</i>. 
The </font><tt>[RStartFrom,CStartFrom]</tt> cell in </font><tt>FROM</tt> is assigned to the </font><tt>[RStartTo,CStartTo]</tt> cell in </font><tt>TO</tt>, and the rest are assigned by first increasing the column number and then the row number 
(e.g. if <i>[1,1]</i> is assigned to <i>[2,3]</i>, <i>[1,2]</i> will be assigned to <i>[2,4]</i> and so on).<br>
In 1D CA only the column indexes are considered (the </font><tt>column_1D_2D</tt> parameter can be used to assign the 1D region as a column to a 2D region instead of a row, 
e.g., cells <i>[1,2,3]</i> wil be assigned to <i>[2,3;3,3;4,3]</i> instead of <i>[2,3:2,4;2,5]</i>).
</p>
<p>
The </font><tt>SetInput</tt> function has to be redeclared as an external function that properly manages the data structures that represent CA states.
</p>
<p>
The communication is performed at discrete time steps of lenght </font><tt>comm_rate</tt>, starting at time </font><tt>comm_start</tt> (e.g., </font><tt>sample(comm_start,comm_rate)</tt>).
</p>
 
 
</HTML>
"),   Icon(coordinateSystem(preserveAspectRatio=false,extent={{-100,-100},{100,
              100}}), graphics={
          Line(
            points={{-10,60},{-10,-60}},
            color={0,0,255},
            smooth=Smooth.None),
          Line(
            points={{10,60},{10,-60}},
            color={0,0,255},
            smooth=Smooth.None),
          Line(
            points={{-30,40},{30,40}},
            color={0,0,255},
            smooth=Smooth.None),
          Line(
            points={{-30,20},{30,20}},
            color={0,0,255},
            smooth=Smooth.None),
          Line(
            points={{-30,0},{30,0}},
            color={0,0,255},
            smooth=Smooth.None),
          Line(
            points={{-30,-20},{30,-20}},
            color={0,0,255},
            smooth=Smooth.None),
          Line(
            points={{-30,-40},{30,-40}},
            color={0,0,255},
            smooth=Smooth.None),
          Text(
            extent={{-60,80},{-40,60}},
            lineColor={0,0,255},
            textString="%CstartFrom"),
          Text(
            extent={{-28,80},{-8,60}},
            lineColor={0,0,255},
            textString="%CendFrom"),
          Text(
            extent={{-40,60},{-20,40}},
            lineColor={0,0,255},
            textString="%RstartFrom"),
          Text(
            extent={{-40,-40},{-20,-60}},
            lineColor={0,0,255},
            textString="%RendFrom"),
          Text(
            extent={{-70,-60},{70,-100}},
            lineColor={0,0,255},
            textString="%name"),
          Text(
            extent={{20,80},{40,60}},
            lineColor={0,0,255},
            textString="%CstartTo"),
          Text(
            extent={{20,60},{40,40}},
            lineColor={0,0,255},
            textString="%RstartTo"),
          Polygon(
            points={{-62,30},{-30,0},{-62,-30},{-62,30}},
            lineColor={0,0,255},
            smooth=Smooth.None,
            fillColor={0,0,255},
            fillPattern=FillPattern.Solid),
          Polygon(
            points={{38,30},{70,0},{38,-30},{38,30}},
            lineColor={0,0,255},
            smooth=Smooth.None,
            fillColor={0,0,255},
            fillPattern=FillPattern.Solid),
          Text(
            extent={{-10,0},{10,-40}},
            lineColor={0,0,0},
            fillColor={0,0,255},
            fillPattern=FillPattern.Solid,
            textString="%input_id"),
          Line(
            points={{-38,70},{-30,70},{-32,72},{-30,70},{-32,68}},
            color={0,0,255},
            smooth=Smooth.None),
          Line(
            points={{-30,36},{-30,-36},{-28,-32},{-30,-36},{-32,-32}},
            color={0,0,255},
            smooth=Smooth.None)}),
      Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{
              100,100}}), graphics));
  end InputRegion;

  connector CAport "Port used for connecting CAs"
    Integer space;
    annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,
              -100},{100,100}}), graphics={Rectangle(
            extent={{-100,100},{100,-100}},
            lineColor={0,0,255},
            fillColor={0,0,255},
            fillPattern=FillPattern.Solid,
            radius=10), Text(
            extent={{-96,40},{98,-40}},
            lineColor={0,0,0},
            fillColor={0,0,255},
            fillPattern=FillPattern.Solid,
            textString="%name")}));
  end CAport;

  package CA_1D "1D Cellular Automata"
    partial model CellSpace1D "1D cellular space"
      parameter Integer Space_ncols=10 "Number of columns of the space";
      parameter Integer[:] neighborhood={-1,1} "Topology of the neighborhood";
      parameter Integer n_inputs=0 "Number of inputs";
      parameter Integer wrapped_borders=0 "1 if border is wrapped, 0 otherwise"
        annotation (choices(choice=0 "No", choice=1 "Yes"));
      parameter Real Tstep=1 "Time between steps";
      parameter Real Initial_step=0 "Time for initial step";
      parameter Integer plot_animation=1
        "1 to plot graphical animation, 0 otherwise";
      parameter Integer plot_range=1 "Maximum value for the animation";
      parameter Integer plot_history=0
        "1 to plot state history (2D graphics), 0 oherwise";
      // 0 false, 1 true
      parameter Integer display_delay=0 "Time delay in the animation";
      //50000 // for usleep()
      parameter Integer[:] init_cells={1} "Positions of cells to initialize";
      parameter String name="1D_CA" "Name of the space";
      replaceable function Rule "Transition rule"
        input Integer s "Reference to the space";
      end Rule;

      replaceable function Create "Creation function"
        input Integer ncols "Number of columns";
        input Integer[:] neighborhood "Topology of the neighborhood";
        input Integer n1=size(neighborhood, 1) "Number of neighbors";
        input Integer n_inputs=0 "Number of inputs";
        input Integer wrapped_borders "1 if border is wrapped, 0 otherwise";
        input Integer plot_animation "1 to generate animation, 0 otherwise";
        input Integer plot_range "Maximum range for values in the animation";
        input Integer Display_delay "Time delay for the animation";
        input Integer plot_history
          "1 to display state history in the animation, 0 otherwise";
        input String path "Path to GNUPlot";
        input String name "Name of the space";
        output Integer s "Reference to the created space";
      end Create;
      Integer s=Create(
              Space_ncols,
              neighborhood,
              size(neighborhood, 1),
              n_inputs,
              wrapped_borders,
              plot_animation,
              plot_range,
              display_delay,
              plot_history,
              Path_gnuplot,
              name);
      replaceable function Initial "Cell initialization function"
        input Integer space "Reference to the space";
        input Integer col "Position to initialize";
      end Initial;

      function Delete
          input Integer s;
        output Integer out;
      external"C" out = CS1D_Delete(s);
        annotation (Include="#include <CellularAutomataLib.c>");
      end Delete;
    protected
      Boolean init(start=false, fixed=true);
    public
      CAport Space "Port to connect with other spaces or interface models"
        annotation (Placement(transformation(extent={{-10,40},{10,60}}),
            iconTransformation(
            extent={{-10,-10},{10,10}},
            rotation=180,
            origin={0,50})));
    algorithm
      when initial() and not init then
        for i in 1:size(init_cells, 1) loop
          Initial(s, init_cells[i]);
        end for;
        init := true;
      end when;
      when terminal() then
        Delete(s);
      end when;
    equation
      Space.space = s;
      when sample(Initial_step, Tstep) then
        Rule(s);
      end when;
      annotation (
        Documentation(info="<HTML>
<p>
This model represents a one-dimensional cellular space.
</p>
<h4>Description</h4>
<p>
This models creates, initializes and executes the simulation of a 1D cellular space. The parameters of the cellular space are:
<ul>
<li> </font><tt>Space_ncols</tt>: describes the number of cells in the space (i.e., the number of columns) 
<li> </font><tt>neighborhood</tt>: describes the topology of the neighborhood. 
Each component of the array represents the relative position of each cell in the neighborhood (e.g., <i>[-2,-1,1,2]</i> represents a neighborhood that includes two cells at each side of the given cell).
<li> </font><tt>n_inputs</tt>: describes the number of inputs received by this space. It usually corresponds to </font><tt>cardinality(Space)</tt>, but not necesarily.
<li> </font><tt>wrapped_borders</tt>: used to set the behavior of the boundaries of the space. Value 1 represents a wrapped boundary and 0 the not wrapped.
<li> </font><tt>plot_animation</tt>: used to decide if the graphical animation of the simulation is generated (value 1) or not (value 0).
<li> </font><tt>plot_range</tt>: maximum range of the value displayed in the graphical animation (e.g., if </font><tt>plot_range = 100</tt> the displayed value can change from 0 to 100).
<li> </font><tt>display_delay</tt>: time delay used to facilitate the visualization of the animation during fast simulations (value in microseconds).
<li> </font><tt>plot_history</tt>: used to decide if the animation includes the past values of the automata, thus generating a two-dimensional graphic.
<li> </font><tt>init_cells</tt>: describes the cells that will be initalized at the begining of the simulation (e.g., <i>[2,3,5]</i> represents that the cells at possitions 2, 3 and 5 will be initalized).
<li> </font><tt>name</tt>: descriptive name for the model that will be displayed in the graphical animation.
<li> </font><tt>Tstep</tt>: describes the duration of the time interval between the updates of state of the cellular space (i.e., time between steps).
<li> </font><tt>Initial_step</tt>: describes the time for the first step.
</ul>
</p>

<p>
The behavior of the model is as follows. At the beginning of the simulation the cellular space model is created by executing the </font><tt>Create</tt> function.
After that, the cells in the positions included in the </font><tt>init_cells</tt> array are initialized using the </font><tt>Initial</tt> function.
The simulation will begin at time </font><tt>Initial_step</tt>, and further steps will be executed every </font><tt>Tstep</tt> time. Each step is performed by executing the </font><tt>Rule</tt> function.
</p>
<p>
The </font><tt>Create</tt>, </font><tt>Initial</tt> and </font><tt>Rule</tt> functions have to be redeclared as external functions to properly manage the data structure that represents the state of the cells, and to describe the update of the state during the transitions.
</p>
 
 
</HTML>
"),     Diagram(coordinateSystem(
            preserveAspectRatio=false,
            extent={{-100,-100},{100,100}},
            initialScale=0.1),graphics),
        experiment(StopTime=100),
        __Dymola_experimentSetupOutput,
        Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{
                100,100}}), graphics={Line(
                  points={{-60,40},{-60,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-40,40},{-40,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-20,40},{-20,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{0,40},{0,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{20,40},{20,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{40,40},{40,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{60,40},{60,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{0,80},{0,-80}},
                  color={0,0,255},
                  smooth=Smooth.None,
                  origin={0,20},
                  rotation=270),Line(
                  points={{0,80},{0,-80}},
                  color={0,0,255},
                  smooth=Smooth.None,
                  origin={0,40},
                  rotation=90),Text(
                  extent={{-80,-20},{80,-60}},
                  lineColor={0,0,255},
                  textString="%name"),Text(
                  extent={{-80,20},{80,-20}},
                  lineColor={0,0,0},
                  textString="[%Space_ncols]"),Line(
                  points={{80,40},{80,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-80,40},{-80,20}},
                  color={0,0,255},
                  smooth=Smooth.None)}));
    end CellSpace1D;

    model ExtInitRegion1D "External Init Region"
      parameter Integer Cstart=1 "region initial column";
      parameter Integer Cend=1 "region final column";
      replaceable function ExtInit "Initialization function"
        input Integer space;
        input Integer col;
        input Real value;
      end ExtInit;
      Modelica.Blocks.Interfaces.RealInput u "External input value" annotation (
         Placement(transformation(extent={{-100,-20},{-60,20}}),
            iconTransformation(extent={{-100,-20},{-60,20}})));
      input CAport TO "Reference to the space to be initialized" annotation (
          Placement(transformation(extent={{-10,-10},{10,10}}),
            iconTransformation(extent={{-10,-10},{10,10}})));
    protected
      Boolean init(start=false, fixed=true);
    algorithm
      when initial() and not init then
        for i in Cstart:Cend loop
          ExtInit(
                TO.space,
                i,
                u);
        end for;
        init := true;
      end when;
      annotation (
        Documentation(info="<HTML>
<p>
This model represents an interface to initialize cells in the space using an external value.
</p>
<h4>Description</h4>
<p>
This model can be used to set the initial state of the cells in the position between </font><tt>Cstart</tt> and </font><tt>Cend</tt> by translating an external value, received through port </font><tt>u</tt>, into the desired cell state.
This translation is performed by the </font><tt>ExtInit</tt> function, that has to be redeclared as an external function to manage the data structure that defines the state.
</p>
 
</HTML>
"),     Icon(coordinateSystem(preserveAspectRatio=false,extent={{-100,-100},{
                100,100}}), graphics={Text(
                  extent={{-50,32},{-30,12}},
                  lineColor={0,0,255},
                  textString="%Cstart"),Text(
                  extent={{30,32},{50,12}},
                  lineColor={0,0,255},
                  textString="%Cend"),Text(
                  extent={{-70,-20},{70,-60}},
                  lineColor={0,0,255},
                  textString="%name"),Line(
                  points={{-30,10},{-30,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-10,10},{-10,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{10,10},{10,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{30,10},{30,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,10},{50,10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,-10},{50,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Text(
                  extent={{-34,30},{34,16}},
                  lineColor={0,0,0},
                  textString="init")}),
        Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                {100,100}}), graphics));
    end ExtInitRegion1D;

    model InputRegion1D = InputRegion (num_dimFrom=1, num_dimTo=1);
    model ExtInputRegion1D "External Input Region"
      parameter Integer input_id=1 "ID for input in TO.space model";
      parameter Integer Cstart=1 "region initial column";
      parameter Integer Cend=1 "region final column";
      parameter Integer Input_type=1 "Input observation method" annotation (
          choices(
          choice=1 "Quantized",
          choice=2 "Cross_UP",
          choice=3 "Cross_DOWN",
          choice=4 "Cross_ANY",
          choice=5 "Sampled"));
      replaceable Real q_t=1 "Quantum or threshold value";
      parameter Real q_aux=1e-010 "Detection value threshold";
      replaceable function ExtInput "Function to set the external input"
        input Integer space "Reference to the space";
        input Integer col "Position of the cell";
        input Real value "Value to use as input";
        input Integer input_id "ID for the input";
      end ExtInput;
      Modelica.Blocks.Interfaces.RealInput u annotation (Placement(
            transformation(extent={{-100,-20},{-60,20}}), iconTransformation(
              extent={{-100,-20},{-60,20}})));
      input CAport TO annotation (Placement(transformation(extent={{-10,-10},{
                10,10}}), iconTransformation(extent={{-10,-10},{10,10}})));
    protected
      Real preEvent(start=u, fixed=true);
      Boolean above(start=u > q_t, fixed=true);
      Boolean below(start=u < q_t, fixed=true);
      Real next_t(start=q_t, fixed=true);
    algorithm
      // FIRST ORDER QUANTIFIER
      when (Input_type == 1) and ((u >= preEvent + q_t + q_aux) or (u <=
          preEvent - q_t - q_aux)) and (time > 0) then
        // ACTUALIZAR ESTADO CELDAS
        //assert(Cstart < 1 or Cstart > CS1D_Size(space) or Cend < 1 or Cend > CS1D_Size(space),"Input Region out of 1D space dimensions", AssertionLevel.error);
        for i in Cstart:Cend loop
          ExtInput(
                TO.space,
                i,
                u,
                input_id);
        end for;
        preEvent := u;
      end when;
      //CROSS UP
    algorithm
      when (Input_type == 2 or Input_type == 4) and (u > q_t) and time > 0 and
          pre(below) then
        below := false;
        // ACTUALIZAR ESTADO CELDAS
        //assert(Cstart < 1 or Cstart > CS1D_Size(space) or Cend < 1 or Cend > CS1D_Size(space),"Input Region out of 1D space dimensions", AssertionLevel.error);
        for i in Cstart:Cend loop
          ExtInput(
                TO.space,
                i,
                u,
                input_id);
        end for;
      end when;
      when (Input_type == 2 or Input_type == 4) and (u < q_t) and time > 0 and
          not below then
        below := true;
      end when;
      //CROSS DOWN
    algorithm
      when (Input_type == 3 or Input_type == 4) and (u < q_t) and time > 0 and
          above then
        // Modelica.Utilities.Streams.print("CROSS DOWN: u "+String(u)+" value "+String(Value));
        above := false;
        // ACTUALIZAR ESTADO CELDAS
        //assert(Cstart < 1 or Cstart > CS1D_Size(space) or Cend < 1 or Cend > CS1D_Size(space),"Input Region out of 1D space dimensions", AssertionLevel.error);
        for i in Cstart:Cend loop
          ExtInput(
                TO.space,
                i,
                u,
                input_id);
        end for;
      end when;
      when (Input_type == 3 or Input_type == 4) and (u > q_t) and time > 0 and
          not above then
        above := true;
      end when;
      // TIME SAMPLER
    algorithm
      when (Input_type == 5 and time >= next_t) then
        // ACTUALIZAR ESTADO CELDAS
        //assert(Cstart < 1 or Cstart > CS1D_Size(space) or Cend < 1 or Cend > CS1D_Size(space),"Input Region out of 1D space dimensions", AssertionLevel.error);
        for i in Cstart:Cend loop
          ExtInput(
                TO.space,
                i,
                u,
                input_id);
        end for;
        next_t := pre(next_t) + q_t;
      end when;
      annotation (
        Documentation(info="<HTML>
<p>
This model represents an interface to set an external value as an input to the cellular space.
</p>
<h4>Description</h4>
<p>
This model can be used to translate an external value, received through port </font><tt>u</tt>, into an input that could be used in the transition rule of the cellular space.
</p>
<p>
Depending on the value of </font><tt>Input_type</tt>, the value of </font><tt>u</tt> is observed in different ways:
<ul>
<li> </font><tt>Input_type = 1</tt> (QUANTIZED): an new input is assigned every time </font><tt>u</tt> changes its value by a given quantum (</font><tt>q_t</tt>).
<li> </font><tt>Input_type = 2</tt> (CROSS_UP): a new input is assigned every time </font><tt>u</tt> crosses </font><tt>q_t</tt> in the upwards direction.
<li> </font><tt>Input_type = 3</tt> (CROSS_DOWN): a new input is assigned every time </font><tt>u</tt> crosses </font><tt>q_t</tt> in the downwards direction.  
<li> </font><tt>Input_type = 4</tt> (CROSS_ANY): a new input is assigned every time </font><tt>u</tt> crosses </font><tt>q_t</tt> in any direction.
<li> </font><tt>Input_type = 5</tt> (SAMPLED): a new input is assigned periodically every </font><tt>q_t</tt> time.
</ul>
The new inputs are assigned to all the cells between positions </font><tt>Cstart</tt> and </font><tt>Cend</tt>.
They are included to the inputs vector of a cell using the </font><tt>input_id</tt>, that could be used to identify the input inside the transition function.
</p>
<p>
The </font><tt>ExtInput</tt> function has to be redeclared as an external function that properly translates the input value to the data structure that represents the state of the cell.
</p>
 
</HTML>
"),     Icon(coordinateSystem(preserveAspectRatio=false,extent={{-100,-100},{
                100,100}}), graphics={Line(
                  points={{-30,10},{-30,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-10,10},{-10,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{10,10},{10,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{30,10},{30,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,10},{50,10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,-10},{50,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Text(
                  extent={{-60,60},{-20,20}},
                  lineColor={0,0,255},
                  textString="%Cstart"),Text(
                  extent={{20,60},{60,20}},
                  lineColor={0,0,255},
                  textString="%Cend"),Text(
                  extent={{-70,-20},{70,-60}},
                  lineColor={0,0,255},
                  textString="%name"),Text(
                  extent={{14,20},{34,-20}},
                  lineColor={0,0,0},
                  fillColor={0,0,255},
                  fillPattern=FillPattern.Solid,
                  textString="%input_id")}),
        Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                {100,100}}), graphics));
    end ExtInputRegion1D;

    model OutputRegion1D "Output Region"
      parameter Integer num_dim=2;
      parameter Integer Cstart=1 "region initial column";
      parameter Integer Cend=1 "region final column";
      parameter Integer Output_type=1 "Output observation method" annotation (
          choices(
          choice=1 "Average",
          choice=2 "Max",
          choice=3 "Min",
          choice=4 "Matrix"));
      parameter Real output_rate "Output sampling interval";
      replaceable function ExtOutput
        input Integer space;
        input Integer col;
        output Real value;
      end ExtOutput;
      Modelica.Blocks.Interfaces.RealOutput y annotation (Placement(
            transformation(extent={{60,-10},{80,10}}), iconTransformation(
              extent={{60,-10},{80,10}})));
    protected
      Real sum;
      Real min;
      Real max;
      Real v;
      Integer n;
    public
      input CAport FROM annotation (Placement(transformation(extent={{-10,-10},
                {10,10}}),iconTransformation(extent={{-10,-10},{10,10}})));
      Modelica.Blocks.Interfaces.RealOutput yM[Cend - Cstart + 1] annotation (
          Placement(transformation(extent={{50,40},{70,60}}),
            iconTransformation(extent={{60,40},{80,60}})));
    algorithm
      when sample(0, output_rate) then
        if Output_type == 1 then
          //AVERAGE
          sum := 0;
          for i in Cstart:Cend loop
            sum := sum + ExtOutput(FROM.space, i);
          end for;
          y := sum/((Cend + 1) - Cstart);
        elseif Output_type == 2 then
          // MAX
          max := -Modelica.Constants.inf;
          for i in Cstart:Cend loop
            v := ExtOutput(FROM.space, i);
            if v > max then
              max := v;
            end if;
          end for;
          y := max;
        elseif Output_type == 3 then
          // MIN
          min := Modelica.Constants.inf;
          for i in Cstart:Cend loop
            v := ExtOutput(FROM.space, i);
            if v < min then
              min := v;
            end if;
          end for;
          y := min;
        end if;
      end when;
    algorithm
      when sample(0, output_rate) then
        if Output_type == 4 then
          n := 1;
          // MATRIX
          for i in Cstart:Cend loop
            yM[n] := ExtOutput(FROM.space, i);
            n := n + 1;
          end for;
        end if;
      end when;
      annotation (
        Documentation(info="<HTML>
<p>
This model represents an interface to observe the state of the cellular space.
</p>
<h4>Description</h4>
<p>
This model translates the state of the space into Real values that can be observed through the </font><tt>y</tt> and </font><tt>yM</tt> ports.
The </font><tt>ExtOutput</tt> function is used to translate the state of a cell into a Real value.
The output value is updated every </font><tt>output_rate</tt> time.
</p>
<p>
Depending on the value of </font><tt>Output_type</tt>, the state is observed in different ways:
<ul>
<li> </font><tt>Output_type = 1</tt> (AVERAGE): the value of </font><tt>y</tt> is calculated as the average value of the states of the cells in the </font><tt>[Cstart:Cend]</tt> interval.
<li> </font><tt>Output_type = 2</tt> (MAX): the value of </font><tt>y</tt> is calculated as the maximum value of the states of the cells in the </font><tt>[Cstart:Cend]</tt> interval.
<li> </font><tt>Output_type = 3</tt> (MIN): the value of </font><tt>y</tt> is calculated as the minimum value of the states of the cells in the </font><tt>[Cstart:Cend]</tt> interval.  
<li> </font><tt>Output_type = 4</tt> (MATRIX): the value of the state of the <i>i</i>-th cell in the space is assigned to </font><tt>yM[n]</tt> (where </font><tt>n=1:(Cend-Cstart+1)</tt>).
</ul>
</p>
<p>
The </font><tt>ExtOutput</tt> function has to be redeclared as an external function that properly translates the data structure that represents the state of the cell into a Real value.
</p>
 
</HTML>
"),     Icon(coordinateSystem(preserveAspectRatio=false,extent={{-100,-100},{
                100,100}}), graphics={Text(
                  extent={{-50,60},{-10,20}},
                  lineColor={0,0,255},
                  textString="%Cstart"),Text(
                  extent={{10,60},{50,20}},
                  lineColor={0,0,255},
                  textString="%Cend"),Text(
                  extent={{-70,-20},{70,-60}},
                  lineColor={0,0,255},
                  textString="%name"),Line(
                  points={{-30,10},{-30,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-10,10},{-10,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{10,10},{10,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{30,10},{30,-10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,10},{50,10}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,-10},{50,-10}},
                  color={0,0,255},
                  smooth=Smooth.None)}),
        Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                {100,100}}), graphics));
    end OutputRegion1D;
    annotation (Documentation(info="<html>
<p>This package contains the models to describe 1D cellular automata.</p>
</html>"));
  end CA_1D;

  package Examples1D "Examples of 1D Cellular Automata"
    model CSR110 "Rule 110"
      extends CA_1D.CellSpace1D(
        Space_ncols=100,
        neighborhood={-1,1},
        wrapped_borders=0,
        Tstep=1,
        Initial_step=1,
        plot_animation=1,
        plot_history=1,
        init_cells={50},
        name="Rule 110",
        redeclare function Initial = R110Init,
        redeclare function Create = R110Create,
        redeclare function Rule = R110Step);
      function R110Step "Rule 110 transition function"
        input Integer s;
        output Integer out;
      external"C" out = R110Step(s);
        annotation (Include="#include <wolfram.c>");
      end R110Step;

      function R110Create "Rule 110 creation function"
        input Integer ncols;
        input Integer[:] neighborhood;
        input Integer n1=size(neighborhood, 1);
        input Integer n_inputs=0;
        input Integer wrapped_borders;
        input Integer plot_animation;
        input Integer plot_range;
        input Integer Display_delay;
        input Integer plot_history;
        input String path;
        input String name;
        output Integer s;
      external"C" s = RCreate(
                ncols,
                neighborhood,
                n1,
                n_inputs,
                wrapped_borders,
                plot_animation,
                plot_range,
                Display_delay,
                plot_history,
                path,
                name);
        annotation (Include="#include <wolfram.c>");
      end R110Create;

      function R110Init "Rule 110 initalization function"
        input Integer space;
        input Integer col;
      external"C" RInitial(space, col);
        annotation (Include="#include <wolfram.c>");
      end R110Init;
      annotation (
        Documentation(info="<HTML>
<p>
This model represents a one-dimensional cellular space following the Rule 110 as defined by Stephen Wolfram.
</p>
<h4>Description</h4>
<p>
This model respresents a cellular space of 100 cells, using the two adjacent cells as neighborhood and un-wrapped borders.
Only the cell located in the position 50 is initialized.<br>
The new state of a cell is computed using the following table, that considers the current state of the cell (center) and its two neighbors (right and left):
</p>

<p>
<table border=1>
<tr>
<th>current state (left,center,right)</th>
<td>111</td>
<td>110</td>
<td>101</td>
<td>100</td>
<td>011</td>
<td>010</td>
<td>001</td>
<td>000</td>
</tr>
<tr>
<th>new state for center cell</th>
<td>0</td>
<td>1</td>
<td>1</td>
<td>0</td>
<td>1</td>
<td>1</td>
<td>1</td>
<td>0</td>
</tr>
</table>
</p>
<p>
The external functions used in the model are included in the file </font><tt>wolfram.c</tt>
</p>
 
 
</HTML>
"),     experiment(StopTime=50),
        __Dymola_experimentSetupOutput);
    end CSR110;

    model CSR30 "Rule 30"
      extends CA_1D.CellSpace1D(
        Space_ncols=100,
        neighborhood={-1,1},
        wrapped_borders=1,
        Tstep=1,
        Initial_step=0,
        plot_animation=1,
        plot_history=1,
        init_cells={50},
        name="Rule 30",
        redeclare function Initial = R30Init,
        redeclare function Create = R30Create,
        redeclare function Rule = R30Step);
      function R30Step "Rule 30 transition function"
        input Integer s;
        output Integer out;
      external"C" out = R30Step(s);
        annotation (Include="#include <wolfram.c>");
      end R30Step;

      function R30Create "Rule 30 creation function"
        input Integer ncols;
        input Integer[:] neighborhood;
        input Integer n1=size(neighborhood, 1);
        input Integer n_inputs=0;
        input Integer wrapped_borders;
        input Integer plot_animation;
        input Integer plot_range;
        input Integer Display_delay;
        input Integer plot_history;
        input String path;
        input String name;
        output Integer s;
      external"C" s = RCreate(
                ncols,
                neighborhood,
                n1,
                n_inputs,
                wrapped_borders,
                plot_animation,
                plot_range,
                Display_delay,
                plot_history,
                path,
                name);
        annotation (Include="#include <wolfram.c>");
      end R30Create;

      function R30Init "Rule 30 initialization function"
        input Integer space;
        input Integer col;
      external"C" RInitial(space, col);
        annotation (Include="#include <wolfram.c>");
      end R30Init;
      annotation (
        Documentation(info="<HTML>
<p>
This model represents a one-dimensional cellular space following the Rule 30 as defined by Stephen Wolfram.
</p>
<h4>Description</h4>
<p>
This model respresents a cellular space of 100 cells, using the two adjacent cells as neighborhood and un-wrapped borders.
Only the cell located in the position 50 is initialized.<br>
The new state of a cell is computed using the following table, that considers the current state of the cell (center) and its two neighbors (right and left):
</p>

<p>
<table border=1>
<tr>
<th>current state (left,center,right)</th>
<td>111</td>
<td>110</td>
<td>101</td>
<td>100</td>
<td>011</td>
<td>010</td>
<td>001</td>
<td>000</td>
</tr>
<tr>
<th>new state for center cell</th>
<td>0</td>
<td>0</td>
<td>0</td>
<td>1</td>
<td>1</td>
<td>1</td>
<td>1</td>
<td>0</td>
</tr>
</table>
</p>
<p>
The external functions used in the model are included in the file </font><tt>wolfram.c</tt>
</p>
 
 
</HTML>
"),     experiment(StopTime=50),
        __Dymola_experimentSetupOutput);
    end CSR30;

    function RSetInput "Input function for Wolfram models"
      input Integer Fspace;
      input Integer Frow;
      input Integer Fcol;
      input Integer Tspace;
      input Integer Trow;
      input Integer Tcol;
      input Integer input_id;
    external"C" RSetInput(
            Fspace,
            Frow,
            Fcol,
            Tspace,
            Trow,
            Tcol,
            input_id);
      annotation (Include="#include <wolfram.c>");
    end RSetInput;

    model input_test "Simple input test"
      CSR30 cSR30_1(
        Space_ncols=10,
        init_cells={5},
        n_inputs=0,
        Initial_step=0.1,
        wrapped_borders=0)
        annotation (Placement(transformation(extent={{-98,0},{-40,40}})));
      CSR30 cSR30_2(
        n_inputs=1,
        Initial_step=0.1,
        init_cells={50},
        Space_ncols=100,
        wrapped_borders=0)
        annotation (Placement(transformation(extent={{20,0},{78,40}})));
      InputRegion inputRegion(
        num_dimFrom=1,
        num_dimTo=1,
        CendFrom=10,
        comm_start=0,
        CstartTo=80,
        redeclare function SetInput = RSetInput)
        annotation (Placement(transformation(extent={{-16,20},{4,40}})));
    equation
      connect(cSR30_1.Space, inputRegion.FROM) annotation (Line(
          points={{-69,30},{-11,30}},
          color={0,0,255},
          smooth=Smooth.None));
      connect(inputRegion.TO, cSR30_2.Space) annotation (Line(
          points={{-1,30},{49,30}},
          color={0,0,255},
          smooth=Smooth.None));
      annotation (
        Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                {100,100}}), graphics),
        experiment(StopTime=10),
        __Dymola_experimentSetupOutput);
    end input_test;

    model bothRules "Two CA models"
      CSR110 cSR110_1
        annotation (Placement(transformation(extent={{-40,0},{-20,20}})));
      CSR30 cSR30_1
        annotation (Placement(transformation(extent={{0,0},{20,20}})));
      annotation (
        Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                {100,100}}), graphics),
        experiment(StopTime=100),
        __Dymola_experimentSetupOutput);
    end bothRules;
  end Examples1D;

  package CA_2D "2D Cellular Automata"
    partial model CellSpace2D
      parameter Integer space_nrows=10 "Number of rows";
      parameter Integer space_ncols=10 "Number of columns";
      parameter Integer[:, 2] neighborhood=[-1, 0; 0, -1; 0, 1; 1, 0];
      // VonNeumann by default;
      parameter Integer n_inputs=0
        "number of inputs (from other CA or external)";
      parameter Integer wrapped_borders=0 annotation (choices(
          choice=0 "None",
          choice=1 "North-South",
          choice=2 "East-West",
          choice=3 "All"));
      // 0 none, 1 north-south, 2 east-west, 3 all
      parameter Real Tstep=1 "Duration time for each step/cicle";
      parameter Real Initial_step=0 "Time for starting the cicles";
      parameter Integer plot_animation=1
        "generate graphical animation (0 false / 1 true)";
      parameter Integer plot_range=1
        "Max range of output for the graphical output";
      parameter Integer display_delay=0
        "Graphical output update delay (in microseconds)";
      parameter Integer[:, 2] init_cells=fill(
              0,
              0,
              2);
      parameter String name="2D_CA";
      replaceable function Rule "Transition function"
        input Integer s;
      end Rule;

      replaceable function Create "Creation function"
        input Integer nrows;
        input Integer ncols;
        input Integer[:, 2] neighborhood;
        input Integer n1=size(neighborhood, 1);
        input Integer n2=2;
        input Integer n_inputs=0;
        input Integer wrapped_borders;
        input Integer plot_animation;
        input Integer plot_range;
        input Integer display_delay;
        input String path;
        input String name;
        output Integer s;
      end Create;
      Integer s=Create(
              space_nrows,
              space_ncols,
              neighborhood,
              size(neighborhood, 1),
              2,
              n_inputs,
              wrapped_borders,
              plot_animation,
              plot_range,
              display_delay,
              Path_gnuplot,
              name);
      replaceable function Initial "Initialization function"
        input Integer space;
        input Integer row;
        input Integer col;
      end Initial;

      function Delete
        input Integer s;
      output Integer out;
      external"C" out = CS2D_Delete(s);
      annotation (Include="#include <CellularAutomataLib.c>");
      end Delete;
    protected
      Boolean init(start=false, fixed=true);
    public
      CAport Space annotation (Placement(transformation(extent={{-10,80},{10,
                100}}), iconTransformation(extent={{-10,80},{10,100}})));
    algorithm
      when initial() and not init then
        for i in 1:size(init_cells, 1) loop
          if init_cells[i, 1] > 0 and init_cells[i, 2] > 0 then
            Initial(
                  s,
                  init_cells[i, 1],
                  init_cells[i, 2]);
          end if;
        end for;
        init := true;
      end when;
      when terminal() then
        Delete(s);
      end when;
    equation
      Space.space = s;
      when sample(Initial_step, Tstep) then
        //Modelica.Utilities.Streams.print("TIME ="+String(time));
        Rule(s);
      end when;
      connect(Space, Space) annotation (Line(
          points={{4.44089e-16,90},{-6,90},{-6,90},{4.44089e-16,90}},
          color={0,0,255},
          smooth=Smooth.None));
      annotation (
        Documentation(info="<HTML>
<p>
This model represents a two-dimensional cellular space.
</p>
<h4>Description</h4>
<p>
This models creates, initializes and executes the simulation of a 2D cellular space. The parameters of the cellular space are:
<ul>
<li> </font><tt>space_nrows</tt>: describes the number of rows in the space.
<li> </font><tt>space_ncols</tt>: describes the number of columns in the space. 
<li> </font><tt>neighborhood</tt>: describes the topology of the neighborhood. 
Each component of the array represents the relative position of each cell in the neighborhood (e.g., <i>[-1,0;0,-1;0,1;1,0]</i> represents the Von Neumann neighborhood).
<li> </font><tt>n_inputs</tt>: describes the number of inputs received by this space. It usually corresponds to </font><tt>cardinality(Space)</tt>, but not necesarily.
<li> </font><tt>wrapped_borders</tt>: used to set the behavior of the boundaries of the space. Value 1 represents a wrapped boundary and 0 the not wrapped.
<li> </font><tt>plot_animation</tt>: used to decide if the graphical animation of the simulation is generated (value 1) or not (value 0).
<li> </font><tt>plot_range</tt>: maximum range of the value displayed in the graphical animation (e.g., if </font><tt>plot_range = 100</tt> the displayed value can change from 0 to 100).
<li> </font><tt>display_delay</tt>: time delay used to facilitate the visualization of the animation during fast simulations (value in microseconds).
<li> </font><tt>plot_history</tt>: used to decide if the animation includes the past values of the automata, thus generating a two-dimensional graphic.
<li> </font><tt>init_cells</tt>: describes the cells that will be initalized at the begining of the simulation (e.g., <i>[2,1;3,1;5,3]</i> represents that the cells at positions <i>[2,1]</i>, <i>[3,1]</i> and <i>[5,3]</i> will be initalized).
<li> </font><tt>name</tt>: descriptive name for the model that will be displayed in the graphical animation.
<li> </font><tt>Tstep</tt>: describes the duration of the time interval between the updates of state of the cellular space (i.e., time between steps).
<li> </font><tt>Initial_step</tt>: describes the time for the first step.
</ul>
</p>

<p>
The behavior of the model is as follows. At the beginning of the simulation the cellular space model is created by executing the </font><tt>Create</tt> function.
After that, the cells in the positions included in the </font><tt>init_cells</tt> array are initialized using the </font><tt>Initial</tt> function.
The simulation will begin at time </font><tt>Initial_step</tt>, and further steps will be executed every </font><tt>Tstep</tt> time. Each step is performed by executing the </font><tt>Rule</tt> function.
</p>
<p>
The </font><tt>Create</tt>, </font><tt>Initial</tt> and </font><tt>Rule</tt> functions have to be redeclared as external functions to properly manage the data structure that represents the state of the cells, and to describe the update of the state during the transitions.
</p>
 
 
</HTML>
"),     Diagram(coordinateSystem(
            preserveAspectRatio=false,
            extent={{-100,-100},{100,100}},
            initialScale=0.1),graphics),
        experiment(StopTime=1000),
        __Dymola_experimentSetupOutput,
        Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{
                100,100}}), graphics={Rectangle(extent={{-80,80},{80,-60}},
              lineColor={0,0,255}),Line(
                  points={{-60,80},{-60,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-40,80},{-40,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-20,80},{-20,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{0,80},{0,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{20,80},{20,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{40,80},{40,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{60,80},{60,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{0,80},{0,-80}},
                  color={0,0,255},
                  smooth=Smooth.None,
                  origin={0,80},
                  rotation=270),Line(
                  points={{0,80},{0,-80}},
                  color={0,0,255},
                  smooth=Smooth.None,
                  origin={0,60},
                  rotation=90),Line(
                  points={{0,80},{0,-80}},
                  color={0,0,255},
                  smooth=Smooth.None,
                  origin={0,40},
                  rotation=90),Line(
                  points={{0,80},{0,-80}},
                  color={0,0,255},
                  smooth=Smooth.None,
                  origin={0,20},
                  rotation=90),Line(
                  points={{0,80},{0,-80}},
                  color={0,0,255},
                  smooth=Smooth.None,
                  origin={0,0},
                  rotation=90),Line(
                  points={{0,80},{0,-80}},
                  color={0,0,255},
                  smooth=Smooth.None,
                  origin={0,-20},
                  rotation=90),Line(
                  points={{0,80},{0,-80}},
                  color={0,0,255},
                  smooth=Smooth.None,
                  origin={0,-40},
                  rotation=90),Text(
                  extent={{-80,-60},{80,-100}},
                  lineColor={0,0,255},
                  textString="%name"),Text(
                  extent={{-80,32},{80,-8}},
                  lineColor={0,0,0},
                  textString="[%space_nrows x %space_ncols]")}));
    end CellSpace2D;

    model ExtInitRegion2D
      parameter Integer Cstart=1 "region initial column";
      parameter Integer Cend=1 "region final column";
      parameter Integer Rstart=1 "region initial row";
      parameter Integer Rend=1 "region final row";
      replaceable function ExtInit "External initalization function"
        input Integer space;
        input Integer row;
        input Integer col;
        input Real value;
      end ExtInit;
      Modelica.Blocks.Interfaces.RealInput u "External input value" annotation (
         Placement(transformation(extent={{-100,-20},{-60,20}}),
            iconTransformation(extent={{-100,-20},{-60,20}})));
    protected
      Boolean init(start=false, fixed=true);
    public
      input CAport TO "Reference to the cellular space" annotation (Placement(
            transformation(extent={{20,-10},{40,10}}), iconTransformation(
              extent={{20,-10},{40,10}})));
    algorithm
      when initial() and not init then
        for i in Rstart:Rend loop
          for j in Cstart:Cend loop
            ExtInit(
                  TO.space,
                  i,
                  j,
                  u);
          end for;
        end for;
        init := true;
      end when;
    equation
      if cardinality(u) == 0 then
        u = 0;
      end if;
      annotation (
        Documentation(info="<HTML>
<p>
This model represents an interface to initialize cells in the space using an external value.
</p>
<h4>Description</h4>
<p>
This model can be used to set the initial state of the cells in the positions between  </font><tt>Rstart</tt> and </font><tt>Rend</tt> (for the rows) and </font><tt>Cstart</tt> and </font><tt>Cend</tt> (for the columns) by translating an external value, received through port </font><tt>u</tt>, into the desired cell state.
This translation is performed by the </font><tt>ExtInit</tt> function, that has to be redeclared as an external function to manage the data structure that defines the state.
</p>
 
</HTML>
"),     Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{
                100,100}}), graphics={Line(
                  points={{-30,60},{-30,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-10,60},{-10,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{10,60},{10,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{30,60},{30,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,40},{50,40}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,20},{50,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,0},{50,0}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,-20},{50,-20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,-40},{50,-40}},
                  color={0,0,255},
                  smooth=Smooth.None),Text(
                  extent={{40,40},{60,20}},
                  lineColor={0,0,255},
                  textString="%Rstart"),Text(
                  extent={{40,-20},{60,-40}},
                  lineColor={0,0,255},
                  textString="%Rend"),Text(
                  extent={{-40,80},{-20,60}},
                  lineColor={0,0,255},
                  textString="%Cstart"),Text(
                  extent={{20,80},{40,60}},
                  lineColor={0,0,255},
                  textString="%Cend"),Text(
                  extent={{-70,-60},{70,-100}},
                  lineColor={0,0,255},
                  textString="%name"),Text(
                  extent={{-50,40},{54,20}},
                  lineColor={0,0,0},
                  textString="init")}),
        Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                {100,100}}), graphics));
    end ExtInitRegion2D;

    model InputRegion2D = InputRegion (num_dimFrom=2, num_dimTo=2);
    model ExtInputRegion2D
      parameter Integer input_id=1 "ID for input in TO.space model";
      parameter Integer Cstart=1 "region initial column";
      parameter Integer Cend=1 "region final column";
      parameter Integer Rstart=1 "region initial row";
      parameter Integer Rend=1 "region final row";
      parameter Integer Input_type=1 "Input observation method" annotation (
          choices(
          choice=1 "Quantized",
          choice=2 "Cross_UP",
          choice=3 "Cross_DOWN",
          choice=4 "Cross_ANY",
          choice=5 "Sampled"));
      replaceable Real q_t=1 "Quantum or threshold value";
      parameter Real q_aux=1e-010 "Detection value threshold";
      replaceable function ExtInput "External input function"
        input Integer space;
        input Integer row;
        input Integer col;
        input Real value;
        input Integer input_id;
      end ExtInput;
      Real Y;
      Modelica.Blocks.Interfaces.RealInput u annotation (Placement(
            transformation(extent={{-100,-20},{-60,20}}), iconTransformation(
              extent={{-100,-20},{-60,20}})));
      Real preEvent(start=u, fixed=true);
      Boolean above(start=u > q_t, fixed=true);
      Boolean below(start=u < q_t, fixed=true);
      Real next_t(start=q_t, fixed=true);
    public
      input CAport TO annotation (Placement(transformation(extent={{20,-10},{40,
                10}}), iconTransformation(extent={{20,-10},{40,10}})));
    algorithm
      // FIRST ORDER QUANTIFIER
      when (Input_type == 1) and ((u >= preEvent + q_t + q_aux) or (u <=
          preEvent - q_t - q_aux)) and (time > 0) then
        // ACTUALIZAR ESTADO CELDAS
        //assert(Rstart < 1 or Rstart > CS2D_SizeRows(space) or Rend < 1 or Rend > CS2D_SizeRows(space)
        //       or Cstart < 1 or Cstart > CS2D_SizeCols(space) or Cend < 1 or Cend > CS2D_SizeCols(space), "Input Region out of 2D space dimensions", AssertionLevel.error);
        for i in Rstart:Rend loop
          for j in Cstart:Cend loop
            ExtInput(
                  TO.space,
                  i,
                  j,
                  u,
                  input_id);
          end for;
        end for;
        preEvent := u;
      end when;
      //CROSS UP
    algorithm
      when (Input_type == 2 or Input_type == 4) and (u > q_t) and time > 0 and
          pre(below) then
        below := false;
        // ACTUALIZAR ESTADO CELDAS
        //assert(Rstart < 1 or Rstart > CS2D_SizeRows(space) or Rend < 1 or Rend > CS2D_SizeRows(space) or Cstart < 1 or Cstart > CS2D_SizeCols(space) or Cend < 1 or Cend > CS2D_SizeCols(space), "Input Region out of 2D space dimensions", AssertionLevel.error);
        for i in Rstart:Rend loop
          for j in Cstart:Cend loop
            //CS2D_Set(space,i-1,j-1,u);
            ExtInput(
                  TO.space,
                  i,
                  j,
                  u,
                  input_id);
          end for;
        end for;
      end when;
      when (Input_type == 2 or Input_type == 4) and (u < q_t) and time > 0 and
          not below then
        below := true;
      end when;
      //CROSS DOWN
    algorithm
      when (Input_type == 3 or Input_type == 4) and (u < q_t) and time > 0 and
          above then
        // Modelica.Utilities.Streams.print("CROSS DOWN: u "+String(u)+" value "+String(Value));
        above := false;
        // ACTUALIZAR ESTADO CELDAS
        //assert(Rstart < 1 or Rstart > CS2D_SizeRows(space) or Rend < 1 or Rend > CS2D_SizeRows(space) or Cstart < 1 or Cstart > CS2D_SizeCols(space) or Cend < 1 or Cend > CS2D_SizeCols(space), "Input Region out of 2D space dimensions", AssertionLevel.error);
        for i in Rstart:Rend loop
          for j in Cstart:Cend loop
            //          CS2D_Set(space,i-1,j-1,u);
            ExtInput(
                  TO.space,
                  i,
                  j,
                  u,
                  input_id);
          end for;
        end for;
      end when;
      when (Input_type == 3 or Input_type == 4) and (u > q_t) and time > 0 and
          not above then
        above := true;
      end when;
      // TIME SAMPLER
    algorithm
      when (Input_type == 5 and time >= next_t) then
        // ACTUALIZAR ESTADO CELDAS
        //assert(Rstart < 1 or Rstart > CS2D_SizeRows(space) or Rend < 1 or Rend > CS2D_SizeRows(space) or Cstart < 1 or Cstart > CS2D_SizeCols(space) or Cend < 1 or Cend > CS2D_SizeCols(space), "Input Region out of 2D space dimensions", AssertionLevel.error);
        for i in Rstart:Rend loop
          for j in Cstart:Cend loop
            //CS2D_Set(space,i-1,j-1,u);
            ExtInput(
                  TO.space,
                  i,
                  j,
                  u,
                  input_id);
            Y := u;
          end for;
        end for;
        next_t := pre(next_t) + q_t;
      end when;
      annotation (
        Documentation(info="<HTML>
<p>
This model represents an interface to set an external value as an input to the cellular space.
</p>
<h4>Description</h4>
<p>
This model can be used to translate an external value, received through port </font><tt>u</tt>, into an input that could be used in the transition rule of the cellular space.
</p>
<p>
Depending on the value of </font><tt>Input_type</tt>, the value of </font><tt>u</tt> is observed in different ways:
<ul>
<li> </font><tt>Input_type = 1</tt> (QUANTIZED): an new input is assigned every time </font><tt>u</tt> changes its value by a given quantum (</font><tt>q_t</tt>).
<li> </font><tt>Input_type = 2</tt> (CROSS_UP): a new input is assigned every time </font><tt>u</tt> crosses </font><tt>q_t</tt> in the upwards direction.
<li> </font><tt>Input_type = 3</tt> (CROSS_DOWN): a new input is assigned every time </font><tt>u</tt> crosses </font><tt>q_t</tt> in the downwards direction.  
<li> </font><tt>Input_type = 4</tt> (CROSS_ANY): a new input is assigned every time </font><tt>u</tt> crosses </font><tt>q_t</tt> in any direction.
<li> </font><tt>Input_type = 5</tt> (SAMPLED): a new input is assigned periodically every </font><tt>q_t</tt> time.
</ul>
The new inputs are assigned to all the cells between positions </font><tt>Rstart</tt> and </font><tt>Rend</tt> (for the rows), and </font><tt>Cstart</tt> and </font><tt>Cend</tt> (for the columns).
They are included to the inputs vector of a cell using the </font><tt>input_id</tt>, that could be used to identify the input inside the transition function.
</p>
<p>
The </font><tt>ExtInput</tt> function has to be redeclared as an external function that properly translates the input value to the data structure that represents the state of the cell.
</p>
 
</HTML>
"),     Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{
                100,100}}), graphics={Line(
                  points={{-30,60},{-30,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-10,60},{-10,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{10,60},{10,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{30,60},{30,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,40},{50,40}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,20},{50,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,0},{50,0}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,-20},{50,-20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,-40},{50,-40}},
                  color={0,0,255},
                  smooth=Smooth.None),Text(
                  extent={{40,40},{60,20}},
                  lineColor={0,0,255},
                  textString="%Rstart"),Text(
                  extent={{40,-20},{60,-40}},
                  lineColor={0,0,255},
                  textString="%Rend"),Text(
                  extent={{-40,80},{-20,60}},
                  lineColor={0,0,255},
                  textString="%Cstart"),Text(
                  extent={{20,80},{40,60}},
                  lineColor={0,0,255},
                  textString="%Cend"),Text(
                  extent={{-70,-60},{70,-100}},
                  lineColor={0,0,255},
                  textString="%name"),Text(
                  extent={{-30,40},{-10,-40}},
                  lineColor={0,0,0},
                  textString="%input_id")}),
        Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                {100,100}}), graphics));
    end ExtInputRegion2D;

    model OutputRegion2D
      parameter Integer Cstart=1 "region initial column";
      parameter Integer Cend=1 "region final column";
      parameter Integer Rstart=1 "region initial row";
      parameter Integer Rend=1 "region final row";
      parameter Integer Output_type=1 "Output observation method" annotation (
          choices(
          choice=1 "Average",
          choice=2 "Max",
          choice=3 "Min",
          choice=4 "Matrix",
          choice=5 "Sum"));
      parameter Real output_rate "Output sampling interval";
      replaceable function ExtOutput "External output function"
        input Integer space;
        input Integer row;
        input Integer col;
        output Real value;
      end ExtOutput;
    protected
      Real sum;
      Real min;
      Real max;
      Real v;
      Integer m,      n;
    public
      input CAport FROM "Reference to cellular space" annotation (Placement(
            transformation(extent={{-10,-10},{10,10}}), iconTransformation(
              extent={{-10,-10},{10,10}})));
      Modelica.Blocks.Interfaces.RealOutput y annotation (Placement(
            transformation(extent={{50,-10},{70,10}}), iconTransformation(
              extent={{50,-10},{70,10}})));
      Modelica.Blocks.Interfaces.RealOutput yM[Rend - Rstart + 1, Cend - Cstart
         + 1] annotation (Placement(transformation(extent={{50,40},{70,60}}),
            iconTransformation(extent={{50,40},{70,60}})));
    algorithm
      when sample(0, output_rate) then
        if Output_type == 1 then
          //AVERAGE
          sum := 0;
          for i in Rstart:Rend loop
            for j in Cstart:Cend loop
              sum := sum + ExtOutput(
                    FROM.space,
                    i,
                    j);
            end for;
          end for;
          y := sum/(((Rend + 1) - Rstart)*((Cend + 1) - Cstart));
        elseif Output_type == 2 then
          // MAX
          max := -Modelica.Constants.inf;
          for i in Rstart:Rend loop
            for j in Cstart:Cend loop
              v := ExtOutput(
                    FROM.space,
                    i,
                    j);
              if v > max then
                max := v;
              end if;
            end for;
          end for;
          y := max;
        elseif Output_type == 3 then
          // MIN
          min := Modelica.Constants.inf;
          for i in Rstart:Rend loop
            for j in Cstart:Cend loop
              v := ExtOutput(
                    FROM.space,
                    i,
                    j);
              if v < min then
                min := v;
              end if;
            end for;
          end for;
          y := min;
        elseif Output_type == 5 then
          //SUM
          sum := 0;
          for i in Rstart:Rend loop
            for j in Cstart:Cend loop
              sum := sum + ExtOutput(
                    FROM.space,
                    i,
                    j);
            end for;
          end for;
          y := sum;
        end if;
      end when;
    algorithm
      when sample(0, output_rate) then
        if Output_type == 4 then
          m := 1;
          n := 1;
          // MATRIX
          for i in Rstart:Rend loop
            for j in Cstart:Cend loop
              yM[m, n] := ExtOutput(
                    FROM.space,
                    i,
                    j);
              n := n + 1;
            end for;
            m := m + 1;
            n := 1;
          end for;
        end if;
      end when;
      annotation (
        Documentation(info="<HTML>
<p>
This model represents an interface to observe the state of the cellular space.
</p>
<h4>Description</h4>
<p>
This model translates the state of the space into Real values that can be observed through the </font><tt>y</tt> and </font><tt>yM</tt> ports.
The </font><tt>ExtOutput</tt> function is used to translate the state of a cell into a Real value.
The output value is updated every </font><tt>output_rate</tt> time.
</p>
<p>
Depending on the value of </font><tt>Output_type</tt>, the state is observed in different ways:
<ul>
<li> </font><tt>Output_type = 1</tt> (AVERAGE): the value of </font><tt>y</tt> is calculated as the average value of the states of the cells in the </font><tt>[Rstart:Rend,Cstart:Cend]</tt> interval.
<li> </font><tt>Output_type = 2</tt> (MAX): the value of </font><tt>y</tt> is calculated as the maximum value of the states of the cells in the </font><tt>[Rstart:Rend,Cstart:Cend]</tt> interval.
<li> </font><tt>Output_type = 3</tt> (MIN): the value of </font><tt>y</tt> is calculated as the minimum value of the states of the cells in the </font><tt>[Rstart:Rend,Cstart:Cend]</tt> interval.  
<li> </font><tt>Output_type = 4</tt> (MATRIX): the value of the state of the <i>i,j</i>-th cell in the space is assigned to </font><tt>yM[m,n]</tt> (where </font><tt>m=1:(Rend-Rstart+1)</tt> and </font><tt>n=1:(Cend-Cstart+1)</tt>).
</ul>
</p>
<p>
The </font><tt>ExtOutput</tt> function has to be redeclared as an external function that properly translates the data structure that represents the state of the cell into a Real value.
</p>
 
</HTML>
"),     Icon(coordinateSystem(preserveAspectRatio=false,extent={{-100,-100},{
                100,100}}), graphics={Line(
                  points={{-30,60},{-30,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-10,60},{-10,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{10,60},{10,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{30,60},{30,-60}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,40},{50,40}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,20},{50,20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,0},{50,0}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,-20},{50,-20}},
                  color={0,0,255},
                  smooth=Smooth.None),Line(
                  points={{-50,-40},{50,-40}},
                  color={0,0,255},
                  smooth=Smooth.None),Text(
                  extent={{-50,100},{-10,60}},
                  lineColor={0,0,255},
                  textString="%Cstart"),Text(
                  extent={{10,100},{50,60}},
                  lineColor={0,0,255},
                  textString="%Cend"),Text(
                  extent={{-90,60},{-50,20}},
                  lineColor={0,0,255},
                  textString="%Rstart"),Text(
                  extent={{-90,0},{-50,-40}},
                  lineColor={0,0,255},
                  textString="%Rend"),Text(
                  extent={{-70,-60},{70,-100}},
                  lineColor={0,0,255},
                  textString="%name"),
            Text(
              extent={{50,46},{70,26}},
              lineColor={0,0,255},
              textString="yM"),
            Text(
              extent={{50,-4},{70,-24}},
              lineColor={0,0,255},
              textString="y")}),
        Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                {100,100}}), graphics));
    end OutputRegion2D;
    annotation (Documentation(info="<html>
<p>This package contains models to describe 2D cellular automata.</p>
</html>"));
  end CA_2D;

  package Examples2D "Examples of 2D Cellular Automata"
    package GameOfLife "Conway's Game of Life"
      model CSGol_random "GOL model with random initalization"
        extends CA_2D.CellSpace2D(
          space_nrows=50,
          space_ncols=50,
          neighborhood=[-1, -1; -1, 0; -1, 1; 0, -1; 0, 1; 1, -1; 1, 0; 1, 1],
          wrapped_borders=3,
          Tstep=1,
          Initial_step=0,
          name="Game of Life (random init)",
          init_cells=randominit(space_ncols, space_nrows),
          redeclare function Rule = GOLStep,
          redeclare function Create = GOLCreate,
          redeclare function Initial = GOLInit);
        function randominit
          input Integer w;
          input Integer h;
          output Integer[6*w, 2] out;
        protected
          Integer k;
        algorithm
          k := 1;
          for i in 1:w loop
            for j in 1:h loop
              if RandomUniform(0) > 0.9 then
                out[k, 1] := i;
                out[k, 2] := j;
                k := k + 1;
              end if;
            end for;
          end for;
        end randominit;

        function GOLStep
          input Integer s;
          output Integer out;
        external"C" out = GOLStep(s);
          annotation (Include="#include <gol.c>");
        end GOLStep;

        function GOLCreate
          input Integer nrows;
          input Integer ncols;
          input Integer[:, 2] neighborhood;
          input Integer n1=size(neighborhood, 1);
          input Integer n2=2;
          input Integer n_inputs=0;
          input Integer wrapped_borders;
          input Integer plot_animation;
          input Integer plot_range;
          input Integer display_delay;
          input String path;
          input String name;
          output Integer s;
        external"C" s = GOLCreate(
                    nrows,
                    ncols,
                    neighborhood,
                    n1,
                    n2,
                    n_inputs,
                    wrapped_borders,
                    plot_animation,
                    plot_range,
                    display_delay,
                    path,
                    name);
          annotation (Include="#include <gol.c>");
        end GOLCreate;

        function GOLInit
          input Integer space;
          input Integer row;
          input Integer col;
        external"C" GOLInitial(
                    space,
                    row,
                    col);
          annotation (Include="#include <gol.c>");
        end GOLInit;
        annotation (experiment(StopTime=100));
      end CSGol_random;

      model CSGol_glider "GOL model initialized with a simple glider"
        extends CA_2D.CellSpace2D(
          space_nrows=50,
          space_ncols=50,
          neighborhood=[-1, -1; -1, 0; -1, 1; 0, -1; 0, 1; 1, -1; 1, 0; 1, 1],
          wrapped_borders=3,
          Tstep=1,
          display_delay=00000,
          plot_animation=1,
          Initial_step=0,
          name="Game of Life (glider)",
          init_cells=[1, 2; 2, 3; 3, 1; 3, 2; 3, 3],
          redeclare function Initial = GOLInit,
          redeclare function Create = GOLCreate,
          redeclare function Rule = GOLStep);
        function GOLStep
          input Integer s;
          output Integer out;
        external"C" out = GOLStep(s);
          annotation (Include="#include <gol.c>");
        end GOLStep;

        function GOLCreate
          input Integer nrows;
          input Integer ncols;
          input Integer[:, 2] neighborhood;
          input Integer n1=size(neighborhood, 1);
          input Integer n2=2;
          input Integer n_inputs=0;
          input Integer wrapped_borders;
          input Integer plot_animation;
          input Integer plot_range;
          input Integer display_delay;
          input String path;
          input String name;
          output Integer s;
        external"C" s = GOLCreate(
                    nrows,
                    ncols,
                    neighborhood,
                    n1,
                    n2,
                    n_inputs,
                    wrapped_borders,
                    plot_animation,
                    plot_range,
                    display_delay,
                    path,
                    name);
          annotation (Include="#include <gol.c>");
        end GOLCreate;

        function GOLInit
          input Integer space;
          input Integer row;
          input Integer col;
        external"C" GOLInitial(
                    space,
                    row,
                    col);
          annotation (Include="#include <gol.c>");
        end GOLInit;
        annotation (experiment(StopTime=100), __Dymola_experimentSetupOutput);
      end CSGol_glider;
    end GameOfLife;

    package Furnace "Simple furnace model"
      model CSFurnace "Furnace model"
        extends CA_2D.CellSpace2D(
          space_nrows=100,
          space_ncols=100,
          neighborhood=[-1, -1; -1, 0; -1, 1; 0, -1; 0, 1; 1, -1; 1, 0; 1, 1],
          wrapped_borders=0,
          Tstep=1,
          Initial_step=0,
          plot_range=1,
          name="Furnace",
          init_cells={{1,i} for i in 1:space_ncols},
          redeclare function Initial = FURInit,
          redeclare function Create = FURCreate,
          redeclare function Rule = FURStep);
        function FURStep
          input Integer s;
          output Integer out;
        external"C" out = FURStep(s);
          annotation (Include="#include <furnace.c>");
        end FURStep;

        function FURCreate
          input Integer nrows;
          input Integer ncols;
          input Integer[:, 2] neighborhood;
          input Integer n1=size(neighborhood, 1);
          input Integer n2=2;
          input Integer n_inputs=0;
          input Integer wrapped_borders;
          input Integer plot_animation;
          input Integer plot_range;
          input Integer display_delay;
          input String path;
          input String name;
          output Integer s;
        external"C" s = FURCreate(
                    nrows,
                    ncols,
                    neighborhood,
                    n1,
                    n2,
                    n_inputs,
                    wrapped_borders,
                    plot_animation,
                    plot_range,
                    display_delay,
                    path,
                    name);
          annotation (Include="#include <furnace.c>");
        end FURCreate;

        function FURInit
          input Integer space;
          input Integer row;
          input Integer col;
        external"C" FURInitial(
                    space,
                    row,
                    col);
          annotation (Include="#include <furnace.c>");
        end FURInit;
        annotation (experiment(StopTime=200),__Dymola_experimentSetupOutput);
      end CSFurnace;

      function FURExtInput
        input Integer space;
        input Integer row;
        input Integer col;
        input Real value;
        input Integer input_id;
      external"C" FURExtInput(
                space,
                row,
                col,
                value,
                input_id);
        annotation (Include="#include <furnace.c>");
      end FURExtInput;

      model FurnaceExtInput
        import ComplexCA = CellularAutomataLib;
        CSFurnace fur(
          space_nrows=20,
          space_ncols=20,
          n_inputs=cardinality(fur.Space))
          annotation (Placement(transformation(extent={{-8,30},{32,70}})));
        CA_2D.ExtInputRegion2D inputRegion(
          Cend=7,
          Input_type=5,
          q_t=0.1,
          Rstart=20,
          Rend=20,
          Cstart=1,
          redeclare function ExtInput = FURExtInput)
          annotation (Placement(transformation(extent={{-54,48},{-2,86}})));
        Modelica.Blocks.Sources.Constant const(k=2)
          annotation (Placement(transformation(extent={{-88,66},{-68,86}})));
      equation
        connect(const.y, inputRegion.u) annotation (Line(
            points={{-67,76},{-62,76},{-62,67},{-48.8,67}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(inputRegion.TO, fur.Space) annotation (Line(
            points={{-20.2,67},{-30,67},{-30,68},{12,68}},
            color={0,0,255},
            smooth=Smooth.None));
        annotation (
          Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                  {100,100}}), graphics),
          experiment(StopTime=10),
          __Dymola_experimentSetupOutput);
      end FurnaceExtInput;

      function FURExtOutput
        input Integer space;
        input Integer row;
        input Integer col;
        output Real value;
      external"C" value = FUROutput(
                space,
                row,
                col);
        annotation (Include="#include <furnace.c>");
      end FURExtOutput;

      model FurnaceOutput
        import ComplexCA = CellularAutomataLib;
        CSFurnace fur(
          space_nrows=20,
          space_ncols=20,
          n_inputs=cardinality(fur.Space))
          annotation (Placement(transformation(extent={{-38,38},{2,78}})));
        CA_2D.ExtInputRegion2D inputRegion(
          Cend=7,
          Input_type=5,
          q_t=0.1,
          Rstart=20,
          Rend=20,
          Cstart=1,
          redeclare function ExtInput = FURExtInput)
          annotation (Placement(transformation(extent={{-66,52},{-46,72}})));
        Modelica.Blocks.Sources.Constant const(k=2)
          annotation (Placement(transformation(extent={{-88,52},{-68,72}})));
        CA_2D.OutputRegion2D outputMatrix(
          Cstart=7,
          Cend=12,
          output_rate=1,
          Output_type=4,
          redeclare function ExtOutput = FURExtOutput,
          Rstart=19,
          Rend=20)
          annotation (Placement(transformation(extent={{-18,10},{2,30}})));
        CA_2D.OutputRegion2D outputAVG(
          output_rate=1,
          Rstart=15,
          Rend=20,
          Cend=20,
          redeclare function ExtOutput = FURExtOutput,
          Cstart=1,
          Output_type=1)
          annotation (Placement(transformation(extent={{-40,12},{-20,32}})));
      equation
        connect(const.y, inputRegion.u) annotation (Line(
            points={{-67,62},{-64,62}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(inputRegion.TO, fur.Space) annotation (Line(
            points={{-53,62},{-36,62},{-36,76},{-18,76}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(outputAVG.FROM, fur.Space) annotation (Line(
            points={{-30,22},{-24,22},{-24,76},{-18,76}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(outputMatrix.FROM, fur.Space) annotation (Line(
            points={{-8,20},{-14,20},{-14,76},{-18,76}},
            color={0,0,255},
            smooth=Smooth.None));
        annotation (
          Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                  {100,100}}), graphics),
          experiment(StopTime=10),
          __Dymola_experimentSetupOutput);
      end FurnaceOutput;

      function FURSetInput
        input Integer Fspace;
        input Integer Frow;
        input Integer Fcol;
        input Integer Tspace;
        input Integer Trow;
        input Integer Tcol;
        input Integer input_id;
      external"C" FURSetInput(
                Fspace,
                Frow,
                Fcol,
                Tspace,
                Trow,
                Tcol,
                input_id);
        annotation (Include="#include <furnace.c>");
      end FURSetInput;

      model FurnaceInput
        import ComplexCA = CellularAutomataLib;
        CSFurnace fur1(
          space_nrows=20,
          space_ncols=20,
          n_inputs=1,
          name="Furnace 1")
          annotation (Placement(transformation(extent={{-44,40},{-4,80}})));
        CA_2D.ExtInputRegion2D inputRegion(
          Cend=7,
          Input_type=5,
          q_t=0.1,
          Rstart=20,
          Rend=20,
          Cstart=1,
          redeclare function ExtInput = FURExtInput)
          annotation (Placement(transformation(extent={{-66,52},{-46,72}})));
        Modelica.Blocks.Sources.Constant const(k=2)
          annotation (Placement(transformation(extent={{-88,52},{-68,72}})));
        CSFurnace fur2(
          space_nrows=20,
          space_ncols=20,
          n_inputs=1,
          name="Furnace 2")
          annotation (Placement(transformation(extent={{60,40},{100,80}})));
        CA_2D.InputRegion2D inputRegion2D(
          CendFrom=10,
          RstartFrom=10,
          RendFrom=20,
          CstartTo=5,
          RstartTo=5,
          redeclare function SetInput = FURSetInput)
          annotation (Placement(transformation(extent={{16,52},{36,72}})));
      equation
        connect(const.y, inputRegion.u) annotation (Line(
            points={{-67,62},{-64,62}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(inputRegion.TO, fur1.Space)
                                           annotation (Line(
            points={{-53,62},{-52,62},{-52,78},{-24,78}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(fur1.Space, inputRegion2D.FROM)
                                               annotation (Line(
            points={{-24,78},{-2,78},{-2,62},{21,62}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(inputRegion2D.TO, fur2.Space) annotation (Line(
            points={{31,62},{56,62},{56,78},{80,78}},
            color={0,0,255},
            smooth=Smooth.None));
        annotation (
          Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                  {100,100}}), graphics),
          experiment(StopTime=10),
          __Dymola_experimentSetupOutput);
      end FurnaceInput;

      model comm
        import ComplexCA = CellularAutomataLib;
        InputRegion inputRegion(
          CendFrom=10,
          CstartTo=50,
          RstartTo=50,
          RendFrom=1,
          redeclare function SetInput = FURSetInput)
          annotation (Placement(transformation(extent={{-38,16},{22,56}})));
        CSFurnace B(
          space_nrows=100,
          space_ncols=100,
          name="SecondCA")
          annotation (Placement(transformation(extent={{-84,-58},{-44,-18}})));
        InputRegion inputRegion1(
          CendFrom=10,
          input_id=2,
          CstartTo=80,
          RstartTo=80,
          RstartFrom=3,
          RendFrom=3,
          redeclare function SetInput = FURSetInput)
          annotation (Placement(transformation(extent={{-40,-52},{20,-12}})));
        CSFurnace A(
          space_nrows=100,
          space_ncols=100,
          name="firstCA")
          annotation (Placement(transformation(extent={{-86,26},{-46,66}})));
        CSFurnace C(
          space_nrows=100,
          space_ncols=100,
          name="thirdCA",
          n_inputs=2)
          annotation (Placement(transformation(extent={{22,-34},{62,6}})));
      equation
        connect(B.Space, inputRegion1.FROM) annotation (Line(
            points={{-64,-20},{-64,-32},{-25,-32}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(A.Space, inputRegion.FROM) annotation (Line(
            points={{-66,64},{-38,64},{-38,36},{-23,36}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(inputRegion.TO, C.Space) annotation (Line(
            points={{7,36},{18,36},{18,4},{42,4}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(inputRegion1.TO, C.Space) annotation (Line(
            points={{5,-32},{18,-32},{18,4},{42,4}},
            color={0,0,255},
            smooth=Smooth.None));
        annotation (
          Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                  {100,100}}), graphics),
          experiment(StopTime=100),
          __Dymola_experimentSetupOutput);
      end comm;

      model comm2
        import ComplexCA = CellularAutomataLib;
        InputRegion inputRegion(
          CendFrom=10,
          CstartTo=50,
          RstartTo=50,
          RendFrom=10,
          redeclare function SetInput = FURSetInput)
          annotation (Placement(transformation(extent={{-30,-20},{30,20}})));
        CSFurnace A(
          space_nrows=100,
          space_ncols=100,
          name="firstCA")
          annotation (Placement(transformation(extent={{-78,-24},{-38,16}})));
        CSFurnace B(
          space_nrows=100,
          space_ncols=100,
          n_inputs=1,
          name="secondCA")
          annotation (Placement(transformation(extent={{36,-24},{76,16}})));
      equation
        connect(A.Space, inputRegion.FROM) annotation (Line(
            points={{-58,14},{-30,14},{-30,0},{-15,0}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(inputRegion.TO, B.Space) annotation (Line(
            points={{15,0},{26,0},{26,14},{56,14}},
            color={0,0,255},
            smooth=Smooth.None));
        annotation (
          Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                  {100,100}}), graphics),
          experiment(StopTime=100),
          __Dymola_experimentSetupOutput);
      end comm2;

    end Furnace;

    package CHIPS "Heat transfer model of a chip"
      model Single_chip
        extends CA_2D.CellSpace2D(
          space_nrows=10,
          space_ncols=10,
          neighborhood=[-1, 0; 0, -1; 0, 1; 1, 0],
          wrapped_borders=0,
          Tstep=1,
          Initial_step=0,
          plot_range=150,
          name="chip",
          init_cells={{i,1} for i in 1:space_ncols},
          redeclare function Initial = CHIPInit,
          redeclare function Create = CHIPCreate,
          redeclare function Rule = SCHIPStep);
        function SCHIPStep
          input Integer s;
          output Integer out;
        external"C" out = SCHIPStep(s);
          annotation (Include="#include <chip.c>");
        end SCHIPStep;

        function CHIPCreate
          input Integer nrows;
          input Integer ncols;
          input Integer[:, 2] neighborhood;
          input Integer n1=size(neighborhood, 1);
          input Integer n2=2;
          input Integer n_inputs=0;
          input Integer wrapped_borders;
          input Integer plot_animation;
          input Integer plot_range;
          input Integer display_delay;
          input String path;
          input String name;
          output Integer s;
        external"C" s = CHIPCreate(
                    nrows,
                    ncols,
                    neighborhood,
                    n1,
                    n2,
                    n_inputs,
                    wrapped_borders,
                    plot_animation,
                    plot_range,
                    display_delay,
                    path,
                    name);
          annotation (Include="#include <chip.c>");
        end CHIPCreate;

        function CHIPInit
          input Integer space;
          input Integer row;
          input Integer col;
        external"C" CHIPInitial(
                    space,
                    row,
                    col);
          annotation (Include="#include <chip.c>");
        end CHIPInit;
        //,[-1,0;0,-1;0,1;1,0],
        annotation (experiment(StopTime=200), __Dymola_experimentSetupOutput);
      end Single_chip;

      model Cair
        extends CA_2D.CellSpace2D(
          space_nrows=10,
          space_ncols=10,
          neighborhood=[-1, 0; 0, -1; 0, 1; 1, 0],
          wrapped_borders=0,
          Tstep=1,
          Initial_step=0,
          plot_range=150,
          init_cells={{1,i} for i in 1:space_ncols},
          redeclare function Initial = CHIPInit,
          redeclare function Create = CHIPCreate,
          redeclare function Rule = AIRStep);
        function AIRStep
          input Integer s;
          output Integer out;
        external"C" out = AIRStep(s);
          annotation (Include="#include <chip.c>");
        end AIRStep;

        function CHIPCreate
          input Integer nrows;
          input Integer ncols;
          input Integer[:, 2] neighborhood;
          input Integer n1=size(neighborhood, 1);
          input Integer n2=2;
          input Integer n_inputs=0;
          input Integer wrapped_borders;
          input Integer plot_animation;
          input Integer plot_range;
          input Integer display_delay;
          input String path;
          input String name;
          output Integer s;
        external"C" s = CHIPCreate(
                    nrows,
                    ncols,
                    neighborhood,
                    n1,
                    n2,
                    n_inputs,
                    wrapped_borders,
                    plot_animation,
                    plot_range,
                    display_delay,
                    path,
                    name);
          annotation (Include="#include <chip.c>");
        end CHIPCreate;

        function CHIPInit
          input Integer space;
          input Integer row;
          input Integer col;
        external"C" CHIPInitial(
                    space,
                    row,
                    col);
          annotation (Include="#include <chip.c>");
        end CHIPInit;
        annotation (experiment(StopTime=200), __Dymola_experimentSetupOutput);
      end Cair;

      model singlechip
        parameter Integer ROWS=10;
        parameter Integer COLS=10;
        parameter Real RATE=0.001;
        Single_chip Chip(
          name="Chip",
          space_nrows=ROWS,
          space_ncols=COLS,
          init_cells=fill(
                    0,
                    0,
                    2),
          wrapped_borders=0,
          Initial_step=0,
          Tstep=RATE,
          display_delay=0,
          plot_range=100,
          n_inputs=4,
          plot_animation=1)
          annotation (Placement(transformation(extent={{4,-40},{44,-10}})));
        CA_2D.ExtInputRegion2D Pext1(
          Input_type=5,
          Cstart=3,
          Cend=3,
          Rstart=1,
          Rend=1,
          q_t=RATE,
          redeclare function ExtInput = CHIPExtInput,
          input_id=3)
          annotation (Placement(transformation(extent={{-14,-28},{6,-8}})));
        CA_2D.ExtInputRegion2D Pext2(
          Cstart=6,
          Cend=6,
          Rstart=6,
          Rend=6,
          Input_type=5,
          q_t=RATE,
          redeclare function ExtInput = CHIPExtInput,
          input_id=4)
          annotation (Placement(transformation(extent={{-14,-48},{6,-28}})));
        Modelica.Blocks.Math.Gain Pg1(k=1/100) annotation (Placement(
              transformation(
              extent={{-4,-4},{4,4}},
              rotation=0,
              origin={-20,-18})));
        SignalGenerators.Trapezoid3sin0100 lG1(
          ampT=60,
          risingT=1,
          widthT=5,
          fallingT=1,
          periodT=10,
          offsetT=20,
          ampS1=10,
          ampS2=5,
          ampS3=6,
          offsetS1=0,
          offsetS2=0,
          offsetS3=0,
          periodS1=4,
          periodS2=10,
          periodS3=12) annotation (Placement(transformation(
              extent={{-7,-6},{7,6}},
              rotation=0,
              origin={-37,-18})));
        Modelica.Blocks.Math.Gain Pg2(k=0.5/100) annotation (Placement(
              transformation(
              extent={{-4,-4},{4,4}},
              rotation=0,
              origin={-20,-38})));
        SignalGenerators.Trapezoid3sin0100 lG2(
          risingT=1,
          fallingT=1,
          offsetS3=3,
          ampT=50,
          widthT=20,
          periodT=50,
          offsetT=10,
          ampS1=4,
          offsetS2=0,
          ampS3=0,
          offsetS1=0,
          ampS2=30,
          periodS2=100,
          periodS1=1,
          periodS3=30) annotation (Placement(transformation(
              extent={{-7.5,-6.5},{7.5,6.5}},
              rotation=0,
              origin={-36.5,-37.5})));
        CA_2D.ExtInitRegion2D InitTemp(
          Cend=ROWS,
          Rend=COLS,
          redeclare function ExtInit = CHIPExtInit)
          annotation (Placement(transformation(extent={{-22,2},{-2,22}})));
        Modelica.Blocks.Sources.Constant const(k=20)
          annotation (Placement(transformation(extent={{-36,6},{-24,18}})));
        Cair Air(
          name="Air",
          space_nrows=ROWS,
          space_ncols=COLS,
          init_cells=fill(
                    0,
                    0,
                    2),
          Tstep=RATE,
          plot_animation=0,
          n_inputs=1)
          annotation (Placement(transformation(extent={{-24,26},{8,46}})));
        InputRegion chipI2Air(
          CstartFrom=1,
          CendFrom=COLS,
          RendFrom=ROWS,
          comm_rate=RATE,
          redeclare function SetInput = CHIPSetInput) annotation (Placement(
              transformation(
              extent={{-20,-10},{20,10}},
              rotation=90,
              origin={-42,36})));
        InputRegion Air2Chip(
          CendFrom=COLS,
          RendFrom=ROWS,
          input_id=1,
          comm_rate=RATE,
          redeclare function SetInput = CHIPSetInput) annotation (Placement(
              transformation(
              extent={{-20,-10},{20,10}},
              rotation=270,
              origin={30,36})));
        CA_2D.OutputRegion2D chipTEMP(
          Cend=COLS,
          Rend=ROWS,
          Output_type=4,
          output_rate=RATE,
          redeclare function ExtOutput = CHIPExtOutput)
          annotation (Placement(transformation(extent={{0,2},{22,22}})));
      equation
        connect(lG1.y, Pg1.u) annotation (Line(
            points={{-31.4,-18},{-24.8,-18}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(Pg1.y, Pext1.u) annotation (Line(
            points={{-15.6,-18},{-12,-18}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(lG2.y, Pg2.u) annotation (Line(
            points={{-30.5,-37.5},{-30.5,-38},{-24.8,-38}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(Pg2.y, Pext2.u) annotation (Line(
            points={{-15.6,-38},{-12,-38}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(const.y, InitTemp.u) annotation (Line(
            points={{-23.4,12},{-20,12}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(chipI2Air.TO, Air.Space) annotation (Line(
            points={{-42,46},{-42,52},{-8,52},{-8,45}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(Air.Space, Air2Chip.FROM) annotation (Line(
            points={{-8,45},{-8,52},{30,52},{30,46}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(chipI2Air.FROM, Chip.Space) annotation (Line(
            points={{-42,26},{-42,0},{24,0},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(Air2Chip.TO, Chip.Space) annotation (Line(
            points={{30,26},{30,0},{24,0},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(InitTemp.TO, Chip.Space) annotation (Line(
            points={{-9,12},{0,12},{0,0},{24,0},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(chipTEMP.FROM, Chip.Space) annotation (Line(
            points={{11,12},{0,12},{0,0},{24,0},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(Pext1.TO, Chip.Space) annotation (Line(
            points={{-1,-18},{4,-18},{4,-6},{24,-6},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(Pext2.TO, Chip.Space) annotation (Line(
            points={{-1,-38},{4,-38},{4,-6},{24,-6},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        annotation (
          Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                  {100,100}}), graphics),
          experiment(StopTime=2),
          __Dymola_experimentSetupOutput,
          Icon(coordinateSystem(extent={{-100,-100},{100,100}})));
      end singlechip;

      function CHIPExtInput
        input Integer space;
        input Integer row;
        input Integer col;
        input Real value;
        input Integer input_id;
      external"C" CHIPExtInput(
                space,
                row,
                col,
                value,
                input_id);
        annotation (Include="#include <chip.c>");
      end CHIPExtInput;

      function CHIPExtOutput
        input Integer space;
        input Integer row;
        input Integer col;
        output Real value;
      external"C" value = CHIPOutput(
                space,
                row,
                col);
        annotation (Include="#include <chip.c>");
      end CHIPExtOutput;

      function CHIPSetInput
        input Integer Fspace;
        input Integer Frow;
        input Integer Fcol;
        input Integer Tspace;
        input Integer Trow;
        input Integer Tcol;
        input Integer input_id;
      external"C" CHIPSetInput(
                Fspace,
                Frow,
                Fcol,
                Tspace,
                Trow,
                Tcol,
                input_id);
        annotation (Include="#include <chip.c>");
      end CHIPSetInput;

      function CHIPExtInit
        input Integer space;
        input Integer row;
        input Integer col;
        input Real value;
      external"C" CHIPExtInit(
                space,
                row,
                col,
                value);
        annotation (Include="#include <chip.c>");
      end CHIPExtInit;

      package SignalGenerators
        model Trapezoid3sin0100
          Modelica.Blocks.Sources.Trapezoid trapezoid(
            amplitude=ampT,
            rising=risingT,
            width=widthT,
            falling=fallingT,
            period=periodT,
            offset=offsetT,
            startTime=startTimeT) annotation (Placement(transformation(extent={{-80,
                    50},{-60,70}}, rotation=0)));
          Modelica.Blocks.Sources.Sine sine1(
            amplitude=ampS1,
            freqHz=1/periodS1,
            offset=offsetS1,
            startTime=startTimeS1) annotation (Placement(transformation(extent={{-80,
                    20},{-60,40}}, rotation=0)));
          Modelica.Blocks.Sources.Sine sine2(
            amplitude=ampS2,
            freqHz=1/periodS2,
            offset=offsetS2,
            startTime=startTimeS2) annotation (Placement(transformation(extent={{-80,
                    -10},{-60,10}}, rotation=0)));
          Modelica.Blocks.Sources.Sine sine3(
            amplitude=ampS3,
            freqHz=1/periodS3,
            offset=offsetS3,
            startTime=startTimeS3) annotation (Placement(transformation(extent={{-80,
                    -40},{-60,-20}}, rotation=0)));
          parameter Real ampT=1;
          parameter Modelica.SIunits.Time risingT=0;
          parameter Modelica.SIunits.Time widthT=0.5;
          parameter Modelica.SIunits.Time fallingT=0;
          parameter Modelica.SIunits.Time periodT=1;
          parameter Real offsetT=0;
          parameter Modelica.SIunits.Time startTimeT=0;
          parameter Real ampS1=1;
          parameter Modelica.SIunits.Time periodS1=1;
          parameter Real offsetS1=0;
          parameter Modelica.SIunits.Time startTimeS1=0;
          parameter Real ampS2=1;
          parameter Modelica.SIunits.Time periodS2=1;
          parameter Real offsetS2=0;
          parameter Modelica.SIunits.Time startTimeS2=0;
          parameter Real ampS3=1;
          parameter Modelica.SIunits.Time periodS3=1;
          parameter Real offsetS3=0;
          parameter Modelica.SIunits.Time startTimeS3=0;
          Modelica.Blocks.Math.Add3 add31 annotation (Placement(transformation(
                  extent={{-40,20},{-20,40}}, rotation=0)));
          Modelica.Blocks.Math.Add add2 annotation (Placement(transformation(extent=
                   {{0,14},{20,34}}, rotation=0)));
          Modelica.Blocks.Nonlinear.Limiter lim0100(uMax=100, uMin=0) annotation (
              Placement(transformation(extent={{36,14},{56,34}}, rotation=0)));
          Modelica.Blocks.Interfaces.RealOutput y annotation (Placement(
                transformation(extent={{60,-20},{100,20}}, rotation=0)));
        equation
          connect(sine1.y, add31.u2)
            annotation (Line(points={{-59,30},{-42,30}}, color={0,0,127}));
          connect(trapezoid.y, add31.u1) annotation (Line(points={{-59,60},{-50,60},
                  {-50,38},{-42,38}}, color={0,0,127}));
          connect(sine2.y, add31.u3) annotation (Line(points={{-59,6.10623e-16},{-50,
                  6.10623e-16},{-50,22},{-42,22}}, color={0,0,127}));
          connect(add31.y, add2.u1)
            annotation (Line(points={{-19,30},{-2,30}}, color={0,0,127}));
          connect(add2.y, lim0100.u)
            annotation (Line(points={{21,24},{34,24}}, color={0,0,127}));
          connect(lim0100.y, y) annotation (Line(points={{57,24},{62,24},{62,
                  1.11022e-15},{80,1.11022e-15}}, color={0,0,127}));
          connect(sine3.y, add2.u2) annotation (Line(points={{-59,-30},{-30,-30},{-30,
                  18},{-2,18}}, color={0,0,127}));
          annotation (Diagram(graphics), Icon(graphics={Rectangle(
                  extent={{-100,100},{100,-100}},
                  lineColor={0,0,0},
                  fillColor={215,215,215},
                  fillPattern=FillPattern.Solid), Text(
                  extent={{-84,54},{50,-52}},
                  lineColor={0,0,0},
                  fillColor={215,215,215},
                  fillPattern=FillPattern.Solid,
                  textString="T+3S+N")}));
        end Trapezoid3sin0100;

        model Trapezoid3sinNoise0100
          Modelica.Blocks.Sources.Trapezoid trapezoid(
            amplitude=ampT,
            rising=risingT,
            width=widthT,
            falling=fallingT,
            period=periodT,
            offset=offsetT,
            startTime=startTimeT) annotation (Placement(transformation(extent={{-80,
                    50},{-60,70}}, rotation=0)));
          Modelica.Blocks.Sources.Sine sine1(
            amplitude=ampS1,
            freqHz=1/periodS1,
            offset=offsetS1,
            startTime=startTimeS1) annotation (Placement(transformation(extent={{-80,
                    20},{-60,40}}, rotation=0)));
          Modelica.Blocks.Sources.Sine sine2(
            amplitude=ampS2,
            freqHz=1/periodS2,
            offset=offsetS2,
            startTime=startTimeS2) annotation (Placement(transformation(extent={{-80,
                    -10},{-60,10}}, rotation=0)));
          Modelica.Blocks.Sources.Sine sine3(
            amplitude=ampS3,
            freqHz=1/periodS3,
            offset=offsetS3,
            startTime=startTimeS3) annotation (Placement(transformation(extent={{-80,
                    -40},{-60,-20}}, rotation=0)));
          noiseGen noiseGen1(
            Ts=TsN,
            amp=ampN,
            Tf=TfN) annotation (Placement(transformation(extent={{-80,-70},{-60,-50}},
                  rotation=0)));
          parameter Real ampT=1;
          parameter Modelica.SIunits.Time risingT=0;
          parameter Modelica.SIunits.Time widthT=0.5;
          parameter Modelica.SIunits.Time fallingT=0;
          parameter Modelica.SIunits.Time periodT=1;
          parameter Real offsetT=0;
          parameter Modelica.SIunits.Time startTimeT=0;
          parameter Real ampS1=1;
          parameter Modelica.SIunits.Time periodS1=1;
          parameter Real offsetS1=0;
          parameter Modelica.SIunits.Time startTimeS1=0;
          parameter Real ampS2=1;
          parameter Modelica.SIunits.Time periodS2=1;
          parameter Real offsetS2=0;
          parameter Modelica.SIunits.Time startTimeS2=0;
          parameter Real ampS3=1;
          parameter Modelica.SIunits.Time periodS3=1;
          parameter Real offsetS3=0;
          parameter Modelica.SIunits.Time startTimeS3=0;
          parameter Modelica.SIunits.Time TsN=0.1;
          parameter Real ampN=0.01;
          parameter Real TfN=1;
          Modelica.Blocks.Math.Add3 add31 annotation (Placement(transformation(
                  extent={{-40,20},{-20,40}}, rotation=0)));
          Modelica.Blocks.Math.Add add1 annotation (Placement(transformation(extent=
                   {{-40,-46},{-20,-26}}, rotation=0)));
          Modelica.Blocks.Math.Add add2 annotation (Placement(transformation(extent=
                   {{0,14},{20,34}}, rotation=0)));
          Modelica.Blocks.Nonlinear.Limiter lim0100(uMax=100, uMin=0) annotation (
              Placement(transformation(extent={{36,14},{56,34}}, rotation=0)));
          Modelica.Blocks.Interfaces.RealOutput y annotation (Placement(
                transformation(extent={{60,-20},{100,20}}, rotation=0)));
        equation
          connect(sine1.y, add31.u2)
            annotation (Line(points={{-59,30},{-42,30}}, color={0,0,127}));
          connect(trapezoid.y, add31.u1) annotation (Line(points={{-59,60},{-50,60},
                  {-50,38},{-42,38}}, color={0,0,127}));
          connect(sine2.y, add31.u3) annotation (Line(points={{-59,6.10623e-16},{-50,
                  6.10623e-16},{-50,22},{-42,22}}, color={0,0,127}));
          connect(sine3.y, add1.u1)
            annotation (Line(points={{-59,-30},{-42,-30}}, color={0,0,127}));
          connect(noiseGen1.y, add1.u2) annotation (Line(points={{-62,-60},{-50,-60},
                  {-50,-42},{-42,-42}}, color={0,0,127}));
          connect(add31.y, add2.u1)
            annotation (Line(points={{-19,30},{-2,30}}, color={0,0,127}));
          connect(add1.y, add2.u2) annotation (Line(points={{-19,-36},{-14,-36},{-14,
                  18},{-2,18}}, color={0,0,127}));
          connect(add2.y, lim0100.u)
            annotation (Line(points={{21,24},{34,24}}, color={0,0,127}));
          connect(lim0100.y, y) annotation (Line(points={{57,24},{62,24},{62,
                  1.11022e-15},{80,1.11022e-15}}, color={0,0,127}));
          annotation (Diagram(graphics), Icon(graphics={Rectangle(
                      extent={{-100,100},{100,-100}},
                      lineColor={0,0,0},
                      fillColor={215,215,215},
                      fillPattern=FillPattern.Solid),Text(
                      extent={{-84,54},{50,-52}},
                      lineColor={0,0,0},
                      fillColor={215,215,215},
                      fillPattern=FillPattern.Solid,
                      textString="T+3S+N")}));
        end Trapezoid3sinNoise0100;

        model noiseGen
          import Modelica.Constants.*;
          constant Real m=2^31 - 1;
          constant Real a=7^5;
          constant Real c=10;
          parameter Modelica.SIunits.Time Ts=0.1 "sampling time";
          parameter Real amp=0.01 "amplitude";
          parameter Real Tf=1 "1st order filter TC";
          discrete Real x;
          discrete Real u;
          Modelica.Blocks.Interfaces.RealOutput y annotation (Placement(
                transformation(extent={{60,-22},{100,22}}, rotation=0)));
        algorithm
          when noEvent(sample(0, Ts)) then
            x := (a*x + c) - div((a*x + c), m)*m;
            u := (x/2e9 - 0.5)*amp;
            y := (Tf*y + Ts*u)/(Tf + Ts);
          end when;
          when initial() then
            x := 1.0;
          end when;
          annotation (Icon(graphics={Rectangle(
                      extent={{-100,100},{100,-100}},
                      lineColor={0,0,0},
                      fillColor={215,215,215},
                      fillPattern=FillPattern.Solid),Text(
                      extent={{-100,76},{84,-62}},
                      lineColor={0,0,0},
                      fillColor={215,215,215},
                      fillPattern=FillPattern.Solid,
                      textString="Noise")}));
        end noiseGen;
      end SignalGenerators;

      model singlechip2
        parameter Integer ROWS=100;
        parameter Integer COLS=100;
        parameter Real RATE=0.0001;
        Single_chip Chip(
          name="Chip",
          space_nrows=ROWS,
          space_ncols=COLS,
          init_cells=fill(
                    0,
                    0,
                    2),
          wrapped_borders=0,
          Initial_step=0,
          Tstep=RATE,
          display_delay=0,
          plot_range=100,
          n_inputs=4,
          plot_animation=0)
          annotation (Placement(transformation(extent={{4,-40},{44,-10}})));
        CA_2D.ExtInputRegion2D Pext1(
          Input_type=5,
          Cstart=3,
          Cend=3,
          Rstart=1,
          Rend=1,
          q_t=RATE,
          redeclare function ExtInput = CHIPExtInput,
          input_id=3)
          annotation (Placement(transformation(extent={{-14,-28},{6,-8}})));
        CA_2D.ExtInputRegion2D Pext2(
          Cstart=6,
          Cend=6,
          Rstart=6,
          Rend=6,
          Input_type=5,
          q_t=RATE,
          redeclare function ExtInput = CHIPExtInput,
          input_id=4)
          annotation (Placement(transformation(extent={{-14,-48},{6,-28}})));
        Modelica.Blocks.Math.Gain Pg1(k=1/100) annotation (Placement(
              transformation(
              extent={{-4,-4},{4,4}},
              rotation=0,
              origin={-20,-18})));
        SignalGenerators.Trapezoid3sin0100 lG1(
          ampT=60,
          risingT=1,
          widthT=5,
          fallingT=1,
          periodT=10,
          offsetT=20,
          ampS1=10,
          ampS2=5,
          ampS3=6,
          offsetS1=0,
          offsetS2=0,
          offsetS3=0,
          periodS1=4,
          periodS2=10,
          periodS3=12) annotation (Placement(transformation(
              extent={{-7,-6},{7,6}},
              rotation=0,
              origin={-37,-18})));
        Modelica.Blocks.Math.Gain Pg2(k=0.5/100) annotation (Placement(
              transformation(
              extent={{-4,-4},{4,4}},
              rotation=0,
              origin={-20,-38})));
        SignalGenerators.Trapezoid3sin0100 lG2(
          risingT=1,
          fallingT=1,
          offsetS3=3,
          ampT=50,
          widthT=20,
          periodT=50,
          offsetT=10,
          ampS1=4,
          offsetS2=0,
          ampS3=0,
          offsetS1=0,
          ampS2=30,
          periodS2=100,
          periodS1=1,
          periodS3=30) annotation (Placement(transformation(
              extent={{-7.5,-6.5},{7.5,6.5}},
              rotation=0,
              origin={-36.5,-37.5})));
        CA_2D.ExtInitRegion2D InitTemp(
          Cend=ROWS,
          Rend=COLS,
          redeclare function ExtInit = CHIPExtInit)
          annotation (Placement(transformation(extent={{-22,2},{-2,22}})));
        Modelica.Blocks.Sources.Constant const(k=20)
          annotation (Placement(transformation(extent={{-36,6},{-24,18}})));
        Cair Air(
          name="Air",
          space_nrows=ROWS,
          space_ncols=COLS,
          init_cells=fill(
                    0,
                    0,
                    2),
          Tstep=RATE,
          plot_animation=0,
          n_inputs=1)
          annotation (Placement(transformation(extent={{-24,26},{8,46}})));
        InputRegion chipI2Air(
          CstartFrom=1,
          CendFrom=COLS,
          RendFrom=ROWS,
          comm_rate=RATE,
          redeclare function SetInput = CHIPSetInput) annotation (Placement(
              transformation(
              extent={{-20,-10},{20,10}},
              rotation=90,
              origin={-42,36})));
        InputRegion Air2Chip(
          CendFrom=COLS,
          RendFrom=ROWS,
          input_id=1,
          comm_rate=RATE,
          redeclare function SetInput = CHIPSetInput) annotation (Placement(
              transformation(
              extent={{-20,-10},{20,10}},
              rotation=270,
              origin={30,36})));
      equation
        connect(lG1.y, Pg1.u) annotation (Line(
            points={{-31.4,-18},{-24.8,-18}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(Pg1.y, Pext1.u) annotation (Line(
            points={{-15.6,-18},{-12,-18}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(lG2.y, Pg2.u) annotation (Line(
            points={{-30.5,-37.5},{-30.5,-38},{-24.8,-38}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(Pg2.y, Pext2.u) annotation (Line(
            points={{-15.6,-38},{-12,-38}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(const.y, InitTemp.u) annotation (Line(
            points={{-23.4,12},{-20,12}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(chipI2Air.TO, Air.Space) annotation (Line(
            points={{-42,46},{-42,52},{-8,52},{-8,45}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(Air.Space, Air2Chip.FROM) annotation (Line(
            points={{-8,45},{-8,52},{30,52},{30,46}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(chipI2Air.FROM, Chip.Space) annotation (Line(
            points={{-42,26},{-42,0},{24,0},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(Air2Chip.TO, Chip.Space) annotation (Line(
            points={{30,26},{30,0},{24,0},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(InitTemp.TO, Chip.Space) annotation (Line(
            points={{-9,12},{0,12},{0,0},{24,0},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(Pext1.TO, Chip.Space) annotation (Line(
            points={{-1,-18},{4,-18},{4,-6},{24,-6},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(Pext2.TO, Chip.Space) annotation (Line(
            points={{-1,-38},{4,-38},{4,-6},{24,-6},{24,-11.5}},
            color={0,0,255},
            smooth=Smooth.None));
        annotation (
          Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{100,
                  100}}),      graphics),
          experiment(StopTime=10),
          __Dymola_experimentSetupOutput,
          Icon(coordinateSystem(extent={{-100,-100},{100,100}})));
      end singlechip2;
    end CHIPS;

    package Chagas
      model chagasCA
        extends CA_2D.CellSpace2D(
          space_nrows=30,
          space_ncols=30,
          neighborhood=[-1, -1; -1, 0; -1, 1; 0, -1; 0, 1; 1, -1; 1, 0; 1, 1],
          n_inputs=0,
          wrapped_borders=0,
          Tstep=1,
          Initial_step=0,
          plot_animation=1,
          plot_range=3,
          display_delay=0,
          init_cells=fill(
                    0,
                    0,
                    2),
          name="Chagas",
          redeclare function Rule = CHAGASRule,
          redeclare function Create = CHAGASCreate,
          redeclare function Initial = CHAGASInitial);
        //[-1, 0; 0, -1; 0, 1; 1, 0],
        function CHAGASRule "Transition function"
          input Integer s;
        external"C" Step(s);
          annotation (Include="#include <chagas.c>");
        end CHAGASRule;

        function CHAGASCreate "Creation function"
          input Integer nrows;
          input Integer ncols;
          input Integer[:, 2] neighborhood;
          input Integer n1=size(neighborhood, 1);
          input Integer n2=2;
          input Integer n_inputs=0;
          input Integer wrapped_borders;
          input Integer plot_animation;
          input Integer plot_range;
          input Integer display_delay;
          input String path;
          input String name;
          output Integer s;
        external"C" s = Create(
                    nrows,
                    ncols,
                    neighborhood,
                    n1,
                    n2,
                    n_inputs,
                    wrapped_borders,
                    plot_animation,
                    plot_range,
                    display_delay,
                    path,
                    name);
          annotation (Include="#include <chagas.c>");
        end CHAGASCreate;

        function CHAGASInitial "Initialization function"
          input Integer space;
          input Integer row;
          input Integer col;
        external"C" Ini(
                    space,
                    row,
                    col);
          annotation (Include="#include <chagas.c>");
        end CHAGASInitial;
      end chagasCA;

      model House
        parameter Integer ROWS=32;
        parameter Integer COLS=32;
        chagasCA chagas(
          plot_range=2,
          space_nrows=ROWS,
          space_ncols=COLS)
          annotation (Placement(transformation(extent={{-40,-2},{0,38}})));
        CA_2D.OutputRegion2D avgA(
          output_rate=1,
          redeclare function ExtOutput = ExtOutputA,
          Output_type=5,
          Cstart=2,
          Cend=COLS - 1,
          Rstart=2,
          Rend=ROWS - 1)
          annotation (Placement(transformation(extent={{20,40},{40,60}})));
        CA_2D.OutputRegion2D avgY(
          output_rate=1,
          redeclare function ExtOutput = ExtOutputY,
          Output_type=5,
          Cstart=2,
          Cend=COLS - 1,
          Rstart=2,
          Rend=ROWS - 1)
          annotation (Placement(transformation(extent={{20,20},{40,40}})));
        CA_2D.ExtInitRegion2D extInitRegion2D(redeclare function ExtInit =
              ForestInit, Rend=ROWS)
          annotation (Placement(transformation(extent={{-82,18},{-54,44}})));
        Modelica.Blocks.Sources.Constant const(k=5)
          annotation (Placement(transformation(extent={{-96,24},{-86,34}})));
        CA_2D.ExtInitRegion2D extInitRegion2D1(
          redeclare function ExtInit = ForestInit,
          Cstart=COLS,
          Cend=COLS,
          Rend=ROWS)
          annotation (Placement(transformation(extent={{-82,-6},{-54,20}})));
        CA_2D.ExtInitRegion2D extInitRegion2D2(
          Cstart=1,
          Rend=1,
          redeclare function ExtInit = ForestInit,
          Cend=COLS)
          annotation (Placement(transformation(extent={{-82,-30},{-54,-4}})));
        CA_2D.ExtInitRegion2D extInitRegion2D3(
          Cstart=1,
          redeclare function ExtInit = ForestInit,
          Cend=COLS,
          Rstart=ROWS,
          Rend=ROWS)
          annotation (Placement(transformation(extent={{-82,-54},{-54,-28}})));
      equation
        connect(chagas.Space, avgA.FROM) annotation (Line(
            points={{-20,36},{6,36},{6,50},{30,50}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(chagas.Space, avgY.FROM) annotation (Line(
            points={{-20,36},{6,36},{6,30},{30,30}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(const.y, extInitRegion2D.u) annotation (Line(
            points={{-85.5,29},{-82,30},{-82,31},{-79.2,31}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(extInitRegion2D.TO, chagas.Space) annotation (Line(
            points={{-63.8,31},{-44,31},{-44,36},{-20,36}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(const.y, extInitRegion2D1.u) annotation (Line(
            points={{-85.5,29},{-85.5,18.5},{-79.2,18.5},{-79.2,7}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(const.y, extInitRegion2D2.u) annotation (Line(
            points={{-85.5,29},{-85.5,6.5},{-79.2,6.5},{-79.2,-17}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(const.y, extInitRegion2D3.u) annotation (Line(
            points={{-85.5,29},{-85.5,-6.5},{-79.2,-6.5},{-79.2,-41}},
            color={0,0,127},
            smooth=Smooth.None));
        connect(extInitRegion2D1.TO, chagas.Space) annotation (Line(
            points={{-63.8,7},{-42.9,7},{-42.9,36},{-20,36}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(extInitRegion2D2.TO, chagas.Space) annotation (Line(
            points={{-63.8,-17},{-63.8,10.5},{-20,10.5},{-20,36}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(extInitRegion2D3.TO, chagas.Space) annotation (Line(
            points={{-63.8,-41},{-63.8,-1.5},{-20,-1.5},{-20,36}},
            color={0,0,255},
            smooth=Smooth.None));
        annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent=
                  {{-100,-100},{100,100}}), graphics),
          experiment(StopTime=50),
          __Dymola_experimentSetupOutput);
      end House;

      function ExtOutputA
        input Integer space;
        input Integer row;
        input Integer col;
        output Real value;
      external"C" value = OutputA(
                space,
                row,
                col);
        annotation (Include="#include <chagas.c>");
      end ExtOutputA;

      function ExtOutputY
        input Integer space;
        input Integer row;
        input Integer col;
        output Real value;
      external"C" value = OutputY(
                space,
                row,
                col);
        annotation (Include="#include <chagas.c>");
      end ExtOutputY;

      function ForestInit "External initalization function"
        input Integer space;
        input Integer row;
        input Integer col;
        input Real value;
      external"C" ExtInit(
                space,
                row,
                col,
                value);
        annotation (Include="#include <chagas.c>");
      end ForestInit;
    end Chagas;

    package Epidemics
      model EpidemicsCA
        extends CA_2D.CellSpace2D(
          space_nrows=50,
          space_ncols=50,
          neighborhood=[-1, -1; -1, 0; -1, 1; 0, -1; 0, 1; 1, -1; 1, 0; 1, 1],
          n_inputs=0,
          wrapped_borders=0,
          Tstep=1,
          Initial_step=0,
          plot_animation=1,
          plot_range=3,
          display_delay=0,
          init_cells={{25,25}},
          name="Chagas",
          redeclare function Rule = ERule,
          redeclare function Create = ECreate,
          redeclare function Initial = EInitial);
        //[-1, 0; 0, -1; 0, 1; 1, 0],
        function ERule "Transition function"
          input Integer s;
        external"C" Step(s);
          annotation (Include="#include <epidemics.c>");
        end ERule;

        function ECreate "Creation function"
          input Integer nrows;
          input Integer ncols;
          input Integer[:, 2] neighborhood;
          input Integer n1=size(neighborhood, 1);
          input Integer n2=2;
          input Integer n_inputs=0;
          input Integer wrapped_borders;
          input Integer plot_animation;
          input Integer plot_range;
          input Integer display_delay;
          input String path;
          input String name;
          output Integer s;
        external"C" s = Create(
                    nrows,
                    ncols,
                    neighborhood,
                    n1,
                    n2,
                    n_inputs,
                    wrapped_borders,
                    plot_animation,
                    plot_range,
                    display_delay,
                    path,
                    name);
          annotation (Include="#include <epidemics.c>");
        end ECreate;

        function EInitial "Initialization function"
          input Integer space;
          input Integer row;
          input Integer col;
        external"C" Ini(
                    space,
                    row,
                    col);
          annotation (Include="#include <epidemics.c>");
        end EInitial;
      end EpidemicsCA;

      function ExtOutputS
        input Integer space;
        input Integer row;
        input Integer col;
        output Real value;
      external"C" value = OutputS(
                space,
                row,
                col);
        annotation (Include="#include <epidemics.c>");
      end ExtOutputS;

      function ExtOutputI
        input Integer space;
        input Integer row;
        input Integer col;
        output Real value;
      external"C" value = OutputI(
                space,
                row,
                col);
        annotation (Include="#include <epidemics.c>");
      end ExtOutputI;

      function ExtOutputR
        input Integer space;
        input Integer row;
        input Integer col;
        output Real value;
      external"C" value = OutputR(
                space,
                row,
                col);
        annotation (Include="#include <epidemics.c>");
      end ExtOutputR;

      model Epidemics500
        EpidemicsCA epidemicsCA(
          plot_range=1,
          name="Epidemics",
          space_nrows=500,
          space_ncols=500,
          init_cells={{250,250}},
          display_delay=0)
          annotation (Placement(transformation(extent={{-24,-4},{20,40}})));
        annotation (
          Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                  {100,100}}), graphics),
          experiment(StopTime=100),
          __Dymola_experimentSetupOutput);
      end Epidemics500;

      model Epidemics50
        EpidemicsCA epidemicsCA(
          plot_range=1,
          name="Epidemics",
          space_nrows=50,
          space_ncols=50,
          init_cells={{25,25}},
          display_delay=50000)
          annotation (Placement(transformation(extent={{-24,-2},{20,42}})));
        CA_2D.OutputRegion2D S(
          Output_type=5,
          output_rate=1,
          redeclare function ExtOutput = ExtOutputS,
          Cend=50,
          Rend=50)
          annotation (Placement(transformation(extent={{40,30},{60,50}})));
        CA_2D.OutputRegion2D I(
          Output_type=5,
          output_rate=1,
          redeclare function ExtOutput = ExtOutputI,
          Cend=50,
          Rend=50)
          annotation (Placement(transformation(extent={{40,12},{60,32}})));
        CA_2D.OutputRegion2D R(
          Output_type=5,
          output_rate=1,
          redeclare function ExtOutput = ExtOutputR,
          Cend=50,
          Rend=50)
          annotation (Placement(transformation(extent={{40,-6},{60,14}})));
      equation
        connect(epidemicsCA.Space, S.FROM) annotation (Line(
            points={{-2,39.8},{24,39.8},{24,40},{50,40}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(I.FROM, epidemicsCA.Space) annotation (Line(
            points={{50,22},{24,22},{24,39.8},{-2,39.8}},
            color={0,0,255},
            smooth=Smooth.None));
        connect(R.FROM, epidemicsCA.Space) annotation (Line(
            points={{50,4},{24,4},{24,39.8},{-2,39.8}},
            color={0,0,255},
            smooth=Smooth.None));
        annotation (
          Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
                  {100,100}}), graphics),
          experiment(StopTime=30),
          __Dymola_experimentSetupOutput);
      end Epidemics50;
    end Epidemics;

    package Forest
      model ForestCA
        extends CA_2D.CellSpace2D(
          space_nrows=30,
          space_ncols=30,
          neighborhood=[-1, -1; -1, 0; -1, 1; 0, 1; 1, 1; 1, 0; 1, -1; 0, -1],
          n_inputs=0,
          wrapped_borders=0,
          Tstep=1,
          Initial_step=0,
          plot_animation=1,
          plot_range=2,
          display_delay=0,
          init_cells={{25,15}},
          name="Chagas",
          redeclare function Rule = FRule,
          redeclare function Create = FCreate,
          redeclare function Initial = FInitial);
        //[-1, 0; 0, -1; 0, 1; 1, 0],
        function FRule "Transition function"
          input Integer s;
        external"C" Step(s);
          annotation (Include="#include <forest.c>");
        end FRule;

        function FCreate "Creation function"
          input Integer nrows;
          input Integer ncols;
          input Integer[:, 2] neighborhood;
          input Integer n1=size(neighborhood, 1);
          input Integer n2=2;
          input Integer n_inputs=0;
          input Integer wrapped_borders;
          input Integer plot_animation;
          input Integer plot_range;
          input Integer display_delay;
          input String path;
          input String name;
          output Integer s;
        external"C" s = Create(
                    nrows,
                    ncols,
                    neighborhood,
                    n1,
                    n2,
                    n_inputs,
                    wrapped_borders,
                    plot_animation,
                    plot_range,
                    display_delay,
                    path,
                    name);
          annotation (Include="#include <forest.c>",Library="m");
        end FCreate;

        function FInitial "Initialization function"
          input Integer space;
          input Integer row;
          input Integer col;
        external"C" Ini(
                    space,
                    row,
                    col);
          annotation (Include="#include <forest.c>");
        end FInitial;
        annotation (experiment(StopTime=300),  __Dymola_experimentSetupOutput);
      end ForestCA;

      function WindExtInput
        input Integer space;
        input Integer row;
        input Integer col;
        input Real value;
        input Integer input_id;
      external"C" WExtInput(
                space,
                row,
                col,
                value,
                input_id);
        annotation (Include="#include <forest.c>");
      end WindExtInput;


      model ForestFire
        ForestCA forest(
          n_inputs=4,
          space_nrows=50,
          space_ncols=50,
          init_cells=[40,25],
          name="Forest")
          annotation (Placement(transformation(extent={{-20,-20},{20,20}})));
        annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,
                  -100},{100,100}}), graphics),
          experiment(StopTime=100),
          __Dymola_experimentSetupOutput);
      end ForestFire;
    end Forest;

  end Examples2D;
  annotation (
    preferredView="info",
    Documentation(info="<html>
<p><b>Cellular Automata Models in Modelica</b> </p>
<p>This library can be used to describe 1D and 2D cellular automata models in Modelica.</p><p>It also include interface models to combine cellular automata with other Modelica models. </p>
<p>In order to automatically generate the graphical animations of the simulations the <a href=\"http://www.gnuplot.info/\">Gnuplot</a> program has to be installed in the computer and the <code>Path_gnuplot</code> varible has to be configured with the right path. </p>
<p><h4>Author:</h4></p>
<p><a href=\"http://www.euclides.dia.uned.es/vsanz\">Victorino Sanz </a></p><p>Dpto. Inform&aacute;tica y Autom&aacute;tica, UNED</p><p>Juan del Rosal, 16</p><p>28040, Madrid</p><p>Spain</p><p>Email: <a href=\"mailto:vsanz@dia.uned.es\">vsanz@dia.uned.es</a></p><p>Website: <a href=\"http://www.euclides.dia.uned.es/vsanz\">www.euclides.dia.uned.es/vsanz</a></p><p>Library website: <a href=\"http://www.euclides.dia.uned.es\">www.euclides.dia.uned.es</a> </p>
<p><h4>Copying:</h4></p>
<p>Licensed by Victorino Sanz under the Modelica License 2 </p><p>Copyright 2013, Victorino Sanz. </p>
<p><i>This Modelica package is <u>free</u> software and the use is completely at <u>your ouwn risk;</u> it can be redistributed and/or modified under the terms of the Modelica license 2, see the license conditions (including the disclaimer of warranty) <a href=\"Modelica://CellularAutomataLib.ModelicaLicense2\">here</a> or at <a href=\"http://www.modelica.org/licenses/ModelicaLicense2\">http://www.modelica.org/licenses/ModelicaLicense2</a> </i></p>
</html>"),
    uses(Modelica(version="3.2"),CHIPs(version="1")));
end CellularAutomataLib;
